#include "cb.h"
#include "cat.h"
CAT cat;
static struct {
  int n_child;
  int tell;
  char *num;
} ct;
static struct {
  int dx[15];
  int step, bar;
  int row, col;
  int rrowp[4];
  int mask[4];
  ushort consoleMode[35];
} ct_ws[2] = {
  {
    {
      0, 0, 0, 0, 0, 0, 0, 
      BAR+84+2-16,
      BAR+132+2-16, 
      BAR+180+2-16,
      BAR+236+2-16, 
      BAR+276+2-16,
      BAR+332+2-16,
      BAR+372+2-16,
      BAR+404+2-16,
    },
    12, BAR,
    WS_ROW0, WS_COL0,
    {28, 25, 23, 19,},
    {0, 0, 10, 0},
    {
      0x0060, 0x02c0, 0x0000, 0x0000, 0x031f, 0x0000, 0x0004, 0x0000,
      0x0419, 0x008a, 0x030a, 0x008a, 0x030a, 0x0046, 0x0406, 0x0046,
      0x0406, 0x0000, 0x008a, 0x0000, 0x0080, 0x0000, 0x008a, 0x0000,
      0x0080, 0x0058, 0x0001, 0x0000, 0x800f, 0x0002, 0x0000, 0x0192,
      0x15, 0x08, 0x0c,
    },
  },
  {
    {
      0, 0, 0, 0, 0, 0, 0, 
      BAR+84+2-16+128,
      BAR+132+2-16+128, 
      BAR+180+2-16+128,
      BAR+236+2-16+128, 
      BAR+276+2-16+128,
      BAR+332+2-16+128,
      BAR+372+2-16+128,
      BAR+404+2-16+128,
    },
    13, BAR+128,
    WS_ROW1, WS_COL1,
    {30, 27, 24, 20,},
    {0, 13, 2, 4},
    {
      0x0060, 0x0322, 0x0000, 0x0000, 0x0397, 0x0000, 0x0004, 0x0000,
      0x0433, 0x008a, 0x038a, 0x008a, 0x038a, 0x0034, 0x0434, 0x0034,
      0x0434, 0x0000, 0x008a, 0x0000, 0x0080, 0x0000, 0x008a, 0x0000,
      0x0080, 0x0058, 0x0001, 0x0000, 0x800f, 0x0000, 0x0000, 0x01ca,
      0x15, 0x08, 0x0c,
    },
  },
};
static unchar ct_pali[] = {
  0,  0,  2,
  0,  0,  2,
  0, 15, 15,
  0,  0,  0,
  8,  4,  4,
  5,  2,  2,
  11, 5,  5,
  12, 6,  6,
  12,12, 12,
  12,12, 12,
  0,  0,  2,
  0, 14,  0, /* .B (man) */
  0,  0,  0,
  0,  0,  0,
  12, 0,  0, /* .I (man) / version */
  0,  0,  0,
};
static int ct_orgreq[] = {
  1 * sizeof(int) + sizeof(int),
  0x00000015,
};
static u_short *ct_orgp = (u_short*)&ct_orgreq[1];
static int ct_rline[128];
static char *ct_chp[] = {
  "... egrep -n",
  "... ls -labF",
  "... du -ab",	
  "... file",
  ".gz zcat",
  ".? groff -Tnippon -mandoc ",
  ".? groff -Tascii -mandoc",
  ".lzh lha",
  ".zip unzip -l",
  ".stdin tar tvf -",
  ".stdin file -",
  ".tar tar tvf",
  ".tgz tar tvfz",
  NULL
};
static char *ct_menu[] = {
  "", "", "", "", "", "", "", 
  " < > ",
  " CRT ", 
  " LIST ", 
  " DU ",
  " GREP ",
  " |! ",
  " * ",
  NULL, 
};
static char *ct_label[] = {
  " CUT", " LGREP", " TGREP", " (stdin)", NULL,
  " SIZE", " PAL", " LINE", NULL,
  " DIR", " FILE", NULL,
  " HELP", " TTY", " LOG", " SYS", " ", 
  " e\010e\010ex\010x\010xi\010i\010it\010t\010t", NULL,
  " tty-?", NULL,
  " SYS0", " SYS1", NULL,
  " 16", " 18", " 20", " 24", NULL,
};
static char ct_num[128] = " ?) ";
static char *ct_mm[] = {
  "BIN",
  "EXEC",
  "INDEX",
  "GREP",
  "PAL",
  "SAVER",
  "Z",
  "MOUSE",
  "SYS0",
  "SYS1",
  "EDITOR",
  "LOOP",
  "KEY",
  "STDIN",
  NULL
};
static char cat_pat[] = "^$[].*\\?";
static int cat_kc[] = {J_SJIS, J_EUC, J_JIS, 0};

void fork_cat(char *pathname)/*cb*/
{
  int s_f, i, j, c_f, shmid;
  CONT *cont;
  LIST *pal;
  struct stat st;
  char ct_str[256];
  
  setpgrp();
  shmid = shmget(IPC_CB+gl.curr, SHMCB_SIZE, 0666);
  cb = (CB*)shmat(shmid, 0, 0);
  cb->l_pid = 0;
  cat.segv = (int)signal(SIGSEGV, (__sighandler_t)clear_segv);
  cat.tell = -1;
  ct.num = ct_num;
  cat.pat = cat_pat;
  cat.kc = cat_kc;
  strcpy(ct_str, ct.num);
  for (i = L_WS; ct_label[i]; i++) {
    ct_str[1] = i-L_WS + '1';
    strcpy(&ct_str[3], ct_label[i]);
    cat.crt = save_list(cat.crt, ct_str, cb->pn, NULL);
  }
  for (i = L_LDIR; ct_label[i]; i++) {
    ct_str[1] = i-L_LDIR + '1';
    strcpy(&ct_str[3], ct_label[i]);
    cat.list = save_list(cat.list, ct_str, cb->pn, NULL);
  }
  for (i = L_HELP; ct_label[i]; i++) {
    ct_str[1] = i-L_HELP + '1';
    strcpy(&ct_str[3], ct_label[i]);
    cat.menu = save_list(cat.menu, ct_str, cb->pn, NULL);
  }
  strcpy(&ct_str[3], ct_label[L_tty]);
  for (j = 0; j < N_TTY_; j++) {
    ct_str[1] = ct_str[8] = j + '1';
    cat.tty = save_list(cat.tty, ct_str, cb->pn, NULL);
  }
  for (i = L_SYS0; ct_label[i]; i++) {
    ct_str[1] = i-L_SYS0 + '1';
    strcpy(&ct_str[3], ct_label[i]);
    cat.sys = save_list(cat.sys, ct_str, cb->pn, NULL);
  }
  for (i = L_16, j = 0; ct_label[i]; i++, j++) {
    ct_rline[j] = atoi(ct_label[i]);
    ct_str[1] = i-L_16 + '1';
    strcpy(&ct_str[3], ct_label[i]);
    cat.wid = save_list(cat.wid, ct_str, cb->pn, NULL);
  }
  ct_rline[j] = 0;
  stat(gl.err, &st);
  cat.err = st.st_size;
  cat.label = ct_label;
  cb->bar = BAR;
  get_time(ct_str, 1);
  sprintf(gl.log, "(cb: %s / loop:%8d)\n", ct_str, -gl.loop);
  ct.tell = save_log("%s", gl.log) + 37;
  init_child();
  strcpy(cb->pathname, "cat.c: init_chp"); /* cb07.config 񼰥ߥ SEGV  */
  init_chp(0, NULL, NULL);
  if (!get_pal(cat.pal, gl.n_pal, &pal)) pal = cat.pal;
  for (i = 0; i < 3*N_PAL; i++) cb->color[i] = pal->l.color[i];
  cb->rline = gl.wid;
  for (i = 0; ; i++) {
    cat.mode[i].p = ct_menu[i];
    if (!ct_menu[i]) break;
  }  
  sw_ws(gl.ws);
  for (j = 0; j < 32; j++) init_base(&cat.base[j]);
  /* ȥǥ쥯ȥ̾ */
  getcwd(cat.work[W_OLD], 255);
  setpathname(NULL, cat.work[W_OLD]);
  strcpy(cat.work[W_DIR], cat.work[W_OLD]);
  strcpy(gl.pathname, cat.work[W_OLD]);
  strcpy(cat.work[W_DU], cat.work[W_OLD]);
  strcpy(cat.work[W_PIPE], " stdin.");
  cat.dir = save_list(cat.dir, cat.work[W_DIR], cb->pn, NULL);
  cb->ff.cld = 1;
  cat.pws = gl.ws;
  cat.pwid = gl.wid;
  if (check_magic(M_FORK) || gl.ky || !pathname) {
    /* ȥǥ쥯ȥΥǡ */
    malloc_file(C_DIR, &cat.base[7], get_child(NULL, "ls", gl.pathname));
    gl.bp = &cat.base[7];
    if (check_magic(M_FORK)) c_f = T_PIPE;
    else {
      cb->ff.lb = E_MENU;
      c_f = C_MENU;
    }
  } else { 
    clear_base(&cat.base[10]);
    if (stat(pathname, &st) < 0) {
      save_log("cb: %s: %s\n", pathname, strerror(errno));
      strcpy(pathname, ".");
      st.st_mode = S_IFDIR;
    }
    strcpy(gl.pathname, pathname);
    if (S_ISDIR(st.st_mode)) {
      strcpy(cat.work[W_DIR], gl.pathname);
      chdir(cat.work[W_DIR]);
      setpathname(NULL, cat.work[W_DIR]);
      strcpy(gl.pathname, cat.work[W_DIR]);
      c_f = C_DIR;
    } else {
      cb->f.man = 1;
      if (*gl.pathname != '/') setpathname(gl.pathname, gl.pathname);
      strcpy(cat.work[W_DIR], gl.pathname);
      get_dir(cat.work[W_DIR]);
      chdir(cat.work[W_DIR]);
      setpathname(NULL, cat.work[W_DIR]);
      malloc_file(C_DIR, &cat.base[7], get_child(NULL, "ls", cat.work[W_DIR]));
      if (!load_list(cat.dir, cat.work[W_DIR], &cb->pn, NULL)) {
	cb->pn.pos = 0;
	cb->pn.y = MY+2;
      }
      cat.dir = save_list(cat.dir, cat.work[W_DIR], cb->pn, NULL);
      c_f = C_FILE;
    }
  }
  cb->vf.stop = 0;
  if (gl.curr) {
    strcpy(cb->tag, cat.label[L_EXIT]);
    *cb->tag = 0xa0;
  }
  if (!check_magic(M_FORK)) kill(cb->c_pid, SIGTSTP);
  cat.skip = 0;
  s_f = S_INIT;
  while (1) {      
    if (check_magic(M_FORK)) set_magic(M_PIPE);
    else {
      do {
	c_f = start_cat(c_f, s_f);
      } while (!cat.skip);
      s_f = S_INIT;
      switch(cat.skip) { /* base ݥ򥹥å */
      case 1: /* üڤؤ */ 
	cb->vf.stop = 0;
	break;
      }
      kill(cb->c_pid, SIGTSTP);
      if (check_magic(M_PIPE)) {
	if (cat.cont && !check_magic(M_INIT)) {
	  if (cb->s_pid <= 0) cont = NULL;
	  else cont = get_cont(cat.cont, cb->s_pid);
	  if (cont) {
	    cb->cons = cont->cons;
	    cat.bi = cont->base;
	    cat.pp = cont->pp;
	    cb->in.fd = cont->fd;
	    cat.row = cont->row;
	    gl.bp = cat.bi;
	    cb->pn.nline = cat.bi->nline;
	    cb->c_f = C_SKIP;
	  }
	}
	if (cb->crt.ws != cat.pws) gl.ws = cb->crt.ws;
	sw_ws(gl.ws);
	if (cb->crt.wid != cat.pwid) gl.wid = cb->crt.wid;
      } else if (check_magic(M_FILE)) {
	if (gl.ws != cat.pws) gl.ws = cat.pws;
	sw_ws(gl.ws);
	if (gl.wid != cat.pwid) gl.wid = cat.pwid;
      }
      if (cb->vf.stop) cb->vf.stop = 0;
      if (!cb->k_pid) free_cat();
      if (!cb->w_pid && *cb->procname) {
	*cb->procname = 0;
	wait(0);
      }
      cb->x--;
    }
    if (check_magic(M_PIPE)) {
      /* ʸ, [ * ] , CRT, LIST ӸŤ M_FILE, M_PIPE  */
      if (cb->ff.lb && cb->ff.lb != E_DU) { 
	do {
	  c_f = load_stack(1);
	} while (cb->ff.lb && cb->ff.lb != E_DU);
	save_stack(c_f);
      }
      if (!gl.curr) strcpy(cb->tag, gl.pathname);
      if (!cb->ff.shift && c_f == C_TTY) c_f = load_stack(1);
      cb->ff.grep = 0;
      cb->ff.lb = E_MENU; /* C_GREP  init_back  cb->ff.shift ݻ */
      if (check_magic(M_FORK)) res_magic(M_FORK);
      else cb->ff.shift = 16;
      s_f = S_PIN;
      if (check_magic(M_INIT)) {
	res_magic(M_INIT);
	cb->c_f = 0; /* cb->c_f == C_SKIP  SEGV */
      } else if (cb->s_pid > 0) /* stdin ɽǤüؤ */
	cb->c_f = C_SKIP; /* ݤʤ */
      strcpy(gl.pathname, cat.label[L_PIPE]);
      c_f = T_PIPE;
      strcpy(&cat.work[W_PIPE][6], itoa(cb->s_pid));
      if (!load_list(cat.pipe, cat.work[W_PIPE], &cb->pn, NULL)) {
	cb->pn.pos = 0;
	cb->pn.y = MY+2;
      }
      cat.skip = 0;
    } else if (check_magic(M_FILE)) {
      if (cb->ff.lb && cb->ff.lb != E_DU) {
	do {
	  c_f = load_stack(1);
	} while (cb->ff.lb && cb->ff.lb != E_DU);
	save_stack(c_f);
      }
      strcpy(cb->tag, gl.pathname);
      if (!cb->ff.shift && c_f == C_TTY) c_f = load_stack(1);
      cb->ff.grep = 0;
      cb->ff.lb = E_MENU;
      cb->ff.shift = 16;
      if (check_magic(M_INIT)) {
	res_magic(M_INIT);
	cb->ff.arc = 0;
	strcpy(gl.pathname, cb->pathname);
	if (stat(gl.pathname, &st) < 0) {/* ե̵̾ */
	  save_log("cb: %s: %s\n", gl.pathname, strerror(errno));
	  get_home(gl.pathname); /* ۡǥ쥯ȥ */
	} else { /* symlink ɤ( '/' ղø奢) */
	  strcpy(cat.work[W_PATH], cb->pathname);
	  strcat(cat.work[W_PATH], "/");
	  if (stat(cat.work[W_PATH], &st) >=0) /* symlink ʤ */
	    strcat(gl.pathname, "/"); /* '/' ղ */
	}    
	if (stat(gl.pathname, &st) < 0) {
	  save_log("cb: %s: %s\n", gl.pathname, strerror(errno));
	  setpathname(NULL, gl.pathname);
	} else { /* ե륢 DIR ˥ǥ쥯ȥ̾¸ */
	  c_f = (S_ISDIR(st.st_mode)) ? C_DIR : C_FILE;
	  strcpy(cat.work[W_OLD], cat.work[W_DIR]);
	  strcpy(cat.work[W_DIR], gl.pathname);
	  for (i = j = 0; (i = tabchrstr(&cat.work[W_DIR][j],'/',0)); j += i) ;
	  cat.work[W_DIR][j] = 0;
	  if (!load_list(cat.dir, cat.work[W_DIR], &cb->pn, NULL)) {
	    cb->pn.pos = 0;
	    cb->pn.y = MY+2;
	  }
	  cat.dir = save_list(cat.dir, cat.work[W_DIR], cb->pn, NULL);
	  if (c_f == C_DIR) {
	    cb->ff.shift = 0;
	    while (cat.n_s) load_stack(0);
	    clear_flag();
	    chdir(cat.work[W_DIR]); /* ǥ쥯ȥλϰư */
	    malloc_file(C_DIR, &cat.base[7], 
			get_child(NULL, "ls", cat.work[W_DIR]));
	  } else cb->f.man = cb->ff.cld = 1; /* ҥץư */
	}
	cb->c_f = cat.skip = 0;
      } else cb->c_f = C_SKIP; /* ݤʤ */
    }
    if (cb->y < MY) cb->y = MY+2;
    cb->magic = M_ACTIVE;
  }
}

void init_child(void)/*cb*/
{
  int i;
  
  for (i = 0; ct_chp[i]; i++) 
    cat.child = save_child(cat.child, ct_chp[i], (i) ? 0 : -1);
  ct.n_child = i;
}

void init_chp(int ws, int *keytab, char *first)/*cb*/
{
  FILE *file;
  int i, flag, n_flag, skip;
  struct stat st;
  char str[256], name[256];
  
  strcpy(name, gl.config);
  for (n_flag = 0; ct_mm[n_flag]; n_flag++) ;
  if (ws <= 0) {
    stat(name, &st);
    cb->saver = 600;
  }
  file = fopen(name, "r");
  for (flag = n_flag, skip = 0; skip >= 0; ) {
    if (!skip)
      do {
	if (!fgets(str, 80, file)) skip = -1;
      } while (skip >= 0 && *str != '-');
    if (skip < 0) continue;
    flag = 0;
    if (strlen(str) >= 2) {
      do {
	if (!(i = tabchrstr(str, ' ', NULL)))
	  if (!(i = tabchrstr(str, '\t', NULL)))
	    if (!(i = tabchrstr(str, '\n', NULL))) continue;
	str[i-1] = 0;
      } while (0);
      for (flag = 0; ct_mm[flag]; flag++) 
	if (!strcmp(ct_mm[flag], &str[1])) break;
      if (ct_mm[flag]) skip = 0;
      else {
	fprintf(stderr, "cb: %s: Illegal option %s\n", name, str);
	skip = 0;
	continue;
      }
    } else {
      skip = 0;
      continue;
    }
    switch(flag) {
    case 0:
    case 1:
    case 2:
    case 3:
      if (ws <= 0) skip = init_bin(file, str, flag);
      break;
    case 4:
      if (ws <= 0) skip = init_pal(file, str);
      break;
    case 5:
      if (ws <= 0) skip = init_saver(file, str);
      break;
    case 6:
      if (ws <= 0) skip = init_z(file, str);
      break;
    case 7:
      if (ws <= 0) skip = init_mouse(file, str);
      break;
    case 8:
      if (ws <= 0) skip = init_sys(file, str, 0);
      break;
    case 9:
      if (ws <= 0) skip = init_sys(file, str, 1);
      break;
    case 10:
      if (ws > 0) skip = init_editor(file, str);
      break;
    case 11:
      if (ws > 0) skip = init_loop(file, str);
      break;
    case 12:
      if (keytab) skip = init_key(file, str, keytab, first);
      break;
    case 13:
      if (!ws) skip = init_stdin(file, str);
      break;
    default:
      skip = 0;
      break;
    }
  }
  fclose(file);
}

void print_child(char arg[])/*cb*/
{
  int i;
  CHILD *child;

  for (child = cat.child; child; child = child->next) {
    if (strcmp(child->argv[3], arg)) continue;
    sprintf(gl.log, "argc=%d,", child->argc);
    for (i = 0; child->argv[i]; i++) 
      sprintf(gl.log, "argv%d=%s,", i, child->argv[i]);
    sprintf(gl.log, "ext=%s\n", child->ext);
    save_log("%s", gl.log);
  }
}

int init_bin(FILE *file, char *str, int g_f)/*cb*/
{
  char *cp;

  while (fgets(str, 80, file)) {
    if (*str == '-') return 1;
    str[tabchrstr(str, '\n', NULL)-1] = '\0';	
    for (cp = str; *cp && *cp != '#' && (*cp == '\t' || *cp == ' '); cp++) ;
    if (*cp && *cp != '#') cat.child = save_child(cat.child, str, g_f);
  }
  return -1;
}

int init_pal(FILE *file, char *str)/*cb*/
{
  int c, i, j, v, skip;
  char color[3*N_PAL];
  
  do {
    if (!fgets(&ct.num[4], 36, file)) return -1;
    ct.num[tabchrstr(ct.num, '\n', 0)-1] = 0;
    for (j = 4; ct.num[j]; j++) if (!isspace(ct.num[j])) break;
  } while (!ct.num[j]);
  for (i = 4; isspace(ct.num[i]) && i < 80; i++) ;
  for (; !isspace(ct.num[i]) && i < 80; i++) ;
  ct.num[i] = 0;
  for (skip = j = 0; j < 3*N_PAL; ) {
    if ((i = fgetc(file)) == EOF) {
      fprintf(stderr, "cb: %s: Format error %s", gl.config, str);
      return -1;
    } else if (i == '#') skip = 1;
    else if (skip) {
      while ((c = fgetc(file)) != '\n') ;
      skip = 0;
    } else if (i == '-') {
      fprintf(stderr, "cb: %s: Format error %s", gl.config, str);
      ungetc(i, file);	
      fgets(str, 80, file);
      return 1;
    } else if (isdigit(i)) {
      v = i - '0';
      i = fgetc(file);
      if (isdigit(i)) {
        v *= 10;
	v += i - '0';
      }
      if (v >= 0 && v <= 15) color[j++] = v;
      else {
        fprintf(stderr, "cb: %s: Illegal code %d %s", gl.config, v, str);
	fgets(str, 80, file);
	return 0;
      }
    }
  }
  if (++cb->n_pal < 10) {
    ct.num[0] = ' ';
    ct.num[1] = cb->n_pal + '0';
  } else {
    ct.num[0] = cb->n_pal / 10 + '0';
    ct.num[1] = cb->n_pal % 10 + '0';
  }
  cat.pal = save_list(cat.pal, ct.num, cb->pn, color);
  if (!isspace(ct.num[0])) ct.num[0] = ' ';
  return 0;
}

int init_sys(FILE *file, char *str, int f)/*cb*/
{
  char *cp;
  int i, j;

  for (i = 1; fgets(str, 80, file) != 0; ) {
    if (*str == '-') return 1;
    for (cp = str; *cp != '\n' && *cp != '#'; cp++)
      if (*cp != '\t' && *cp != ' ') break;
    if (*cp == '\n' || *cp == '#') continue;
    cp[tabchrstr(cp, '\n', NULL)-1] = '\0';	
    if ((j = tabchrstr(cp, '#', NULL))) cp[j-1] = '\0';
    if (i < 10) {
      ct.num[0] = ' ';
      ct.num[1] = i + '0';
    } else {
      ct.num[0] = i / 10 + '0';
      ct.num[1] = i % 10 + '0';
    }
    i++;
    strcpy(&ct.num[4], cp);
    switch(f) {
    case 0:
      cat.sys0 = save_list(cat.sys0, ct.num, cb->pn, NULL);
      break;
    case 1:
      cat.sys1 = save_list(cat.sys1, ct.num, cb->pn, NULL);
      break;
    }
  }
  if (!isspace(ct.num[0])) ct.num[0] = ' ';
  return -1;
}

int init_editor(FILE *file, char *str)/*cb*/
{
  int c, i, j, v, skip;

  for (skip = j = 0; j < 3*3;) {
    if ((i = fgetc(file)) == EOF) {
      fprintf(stderr, "cb: %s: Format error %s", gl.config, str);
      return -1;
    } else if (i == '#') skip = 1;
    else if (skip) {
      while ((c = fgetc(file)) != '\n') ;
      skip = 0;
    } else if (i == '-') {
      fprintf(stderr, "cb: %s: Format error %s", gl.config, str);
      ungetc(i, file);	
      fgets(str, 80, file);
      return 1;
    } else if (isdigit(i)) {
      v = i - '0';
      i = fgetc(file);
      if (isdigit(i)) {
        v *= 10;
	v += i - '0';
      }
      if (v >= 0 && v <= 15) gl.color[j++] = v;
      else {
        fprintf(stderr, "cb: %s: Illegal code %d %s", gl.config, v, str);
	fgets(str, 80, file);
	return 0;
      }
    }
  }
  return 0;
}

int init_saver(FILE *file, char *str)/*cb*/
{
  char *sp;
  int i;

  cb->saver = 600;
  if ((sp = get_val(file, str, &i)) == NULL) return i;
  if (!(cb->saver = atoi(sp) * 60)) cb->saver = 15*60;
  return 0;
}

int init_loop(FILE *file, char *str)/*cb*/
{
  char *sp;
  int i;

  cb->loop = 0;
  if ((sp = get_val(file, str, &i)) == NULL) return i;
  cb->loop = atoi(sp);
  return 0;
}

int init_stdin(FILE *file, char *str)/*cb*/
{
  char *sp;
  int i;

  if ((sp = get_val(file, str, &i)) == NULL) return i;
  cb->crt.ws = atoi(sp);
  if ((sp = get_val(file, str, &i)) == NULL) return i;
  cb->crt.wid = atoi(sp);
  return 0;
}

int init_z(FILE *file, char *str)/*cb*/
{
  char *sp;
  int i;

  if ((sp = get_val(file, str, &i)) == NULL) return i;
  gl.z = atoi(sp) * 1024;
  return 0;
}

#ifdef	OLD_IMPREMENT
int init_mouse(FILE *file, char *str)/*cb*/
{
  char *sp;
  int i;

  if ((sp = get_val(file, str, &i)) == NULL) return i;
  cb->mouse = atoi(sp);
  return 0;
}
#else
int init_mouse(FILE *file, char *str)/*cb*/
{
  int status = 0;
  char *sp;
  int counter;
  static const char *keyword[3] = {"townsMouse", "Busmouse", NULL};
  FILE *fp = NULL;

  do {
    if (!fgets(str, 80, file)) {
      return(-1);
      break;
    }
    str[tabchrstr(str, '\n', NULL)-1] = '\0';	
    sp = str + strspn(str, " \t\r,");
    switch(isdigit(*sp)) {
    default:
      if(fp != NULL)
		  fprintf(fp, "No Protocol:%d: %s\n", cb->protocol, sp);
      status |= 0x01;
      cb->mouse = atoi(sp);
      break;
    case 0:
      for(counter = 0;keyword[counter] != NULL;++counter) {
      if(fp != NULL)
      	fprintf(fp, "Protocol:%d: %s\n", cb->protocol, sp);
	if(strncmp(sp, keyword[counter], strlen(keyword[counter])) == 0) {
	  cb->protocol = counter;
	  status |= 0x02;
	}
      }
      break;
    }
  } while (*str != '-');
  return status & 0x01;
}
#endif	/*OLD_IMPREMENT*/

int init_key(FILE *file, char *str, int *keytab, char first[])/*cb*/
{
  int c, i, n_first;
  char *se, *sp;

  for (i = 0; i < 256; i++) first[i] = 0;
  for (i = 1, n_first = 0; ; i++) {
    do {
      if (!(se = fgets(str, 80, file)) || *str == '-') return (se) ? 1 : 0;
      str[tabchrstr(str, '\n', NULL)-1] = '\0';	
      for (sp = str; *sp && *sp != '#' && isspace(*sp); sp++) ;
    } while (!*sp || *sp == '#');
    for (c = 0, se = sp + strlen(sp); sp < se; ) {
      if (!strncmp(sp, "C_", 2)) {
	sp += 2;
	c |= SH + *sp++ - 'a';
	while (*sp && *sp != '#' && isspace(*sp)) sp++;
	if (!*sp || *sp == '#') break;
	if (!tabchrstr(first, c, NULL)) first[n_first++] = c;
	c <<= 8;
      } else if (!strncmp(sp, "S_", 2)) {
	sp += 2;
	c |= 'A' + *sp++ - 'a';
	while (*sp && *sp != '#' && isspace(*sp)) sp++;
	if (!*sp || *sp == '#') break;
	if (!tabchrstr(first, c, NULL)) first[n_first++] = c;
	c <<= 8;
      } else if (!strncmp(sp, "X_", 2) || !strncmp(sp, "M_", 2)) {
	sp += 2;
	c |= EC;
	c <<= 8;
      } else if (!strncmp(sp, "PF", 2)) {
	c = PF + ((isdigit(sp[3])) ? 10+sp[3]-'1' : sp[2]-'1');
	sp = se;
      } else {
	c |= *sp++;
	while (*sp && *sp != '#' && isspace(*sp)) sp++;
	if (!*sp || *sp == '#') break;
	if (!tabchrstr(first, c, NULL)) first[n_first++] = c;	
	c <<= 8;
      }
    }
    keytab[i] = c;
  }
}

char *get_val(FILE *file, char str[], int *ip)/*cb*/
{
  char *sp;

  do {
    if (!fgets(str, 80, file) || *str == '-') {
      *ip = (*str == '-') ? 1 : -1;
      return NULL;
    }
    str[tabchrstr(str, '\n', NULL)-1] = '\0';	
    for (sp = str; *sp && *sp != '#' && !isdigit(*sp); sp++) ;
  } while (!isdigit(*sp));
  *ip = 0;
  return sp;
}

void free_cat(void)/*cb*/
{ /* cb->c_pid ץưŪ˳ݤΰ */
  int i;
  CHILD *chp, *chb;
  FILE *fd;
  CONT *cont;
  
  if (cb->vf.config == 1) {
    for (i = 0, chb = chp = cat.child; i < ct.n_child; i++, chp = chp->next) 
      chb = chp;
    free_child(chp, cat.new);
    free_list(cat.pal);
    free_list(cat.sys0);
    free_list(cat.sys1);
    cat.sys0 = cat.sys1 = cat.pal = NULL;
    cb->n_pal = 0;
    chb->next = NULL;
    init_chp(-1, NULL, NULL);
    for (chp = chb; chp->next; chp = chp->next) ;
    chp->next = cat.new;
    cat.help = make_help(cat.help);
    if (cb->loop) {
      set_delay(-cb->loop);
      fd = fopen(gl.err, "r+");
      fseek(fd, ct.tell, 0);
      fprintf(fd, "%8d", cb->loop);
      fclose(fd);
      cb->loop = 0;
    }
  } else {
    signal(SIGSEGV, (__sighandler_t)cat.segv);
    if (cb->w_pid) kill(cb->w_pid, SIGKILL);
    cb->w_pid = cb->k_pid = 0;
    if (gl.curr) {
      if (cb->in.fd) fclose(cb->in.fd);
      strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], itoa(gl.curr));
      unlink(gl.fifo[0]);
    } else
      do {
	if (!(cont = cat.cont)) break;
      } while ((cat.cont = del_cont(cat.cont, cont->pid)));
    free_child(cat.child, NULL);
    for (i = 0; cat.stack[i]; i++) {
      free((cat.stack[i])->tag);
      free((cat.stack[i])->pathname);
      free((cat.stack[i])->w_dir);
      free((cat.stack[i])->w_old);
      if ((cat.stack[i])->ky_str) free((cat.stack[i])->ky_str);
      free(cat.stack[i]);
    }
    free_list(cat.list_list);
    free_list(cat.file);
    free_list(cat.dir);
    free_list(cat.du);
    free_list(cat.cut);
    free_list(cat.key);
    free_list(cat.cgrep);
    free_list(cat.tgrep);
    free_list(cat.pipe);
    free_list(cat.menu);
    free_list(cat.tty);
    free_list(cat.pal);
    free_list(cat.wid);
    free_list(cat.sys);
    free_list(cat.sys0);
    free_list(cat.sys1);
    free_list(cat.crt);
    free_list(cat.list);
    if (cat.help) free(cat.help);
    for (i = 0; i < 32; i++) free_base(&cat.base[i]);
    cb->c_pid = 0;
    shmdt((char*)cb);
    exit(0);
  }
}

CONT *add_cont(CONT *cont, int pid)/*cb*/
{ /* ¾üΥץϿ */
  if (!cont) {
    cont = calloc(sizeof(CONT), 1);
    cont->next = NULL;
    cont->pid = pid;
    cont->cons = cb->cons;
    cont->base = cat.bi;
  } else if (cont->pid != pid) cont->next = add_cont(cont->next, pid);
  return cont;
}

CONT *del_cont(CONT *cont, int pid)/*cb*/
{ /* ¾üΥץ */
  if (cont && cont->pid == pid) {
    if (cont->fd) fclose(cont->fd);
    strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], itoa(cont->pid));
    unlink(gl.fifo[0]);
    cb->s_pid = cont->pid;
    kill(-cont->pid, SIGCONT);
    free_base(cont->base);
    free(cont->base);
    if (cont->next) {
      CONT *contb = cont;
      cont = cont->next;
      free(contb);
    } else {
      free(cont);
      cont = NULL;
    }
  } else if (cont) cont->next = del_cont(cont->next, pid);
  return cont;
}

CONT *get_cont(CONT *cont, int pid)/*cb*/
{ /* pid ץ cont  */
  while (cont && cont->pid != pid) cont = cont->next;
  return cont;
}

void print_cont(CONT *cont)/*cb*/
{ /* ǥХå */
  while (cont) {
    sprintf(gl.log,"print_cont:cont->pid=%d,cont->base=%x\n",
	    cont->pid, (int)cont->base);
    save_log("%s", gl.log);
    cont = cont->next;
  }
}

void init_base(BASE *base)/*cb*/
{  /* Ǥɽʬ */
  int i;

  for (i = 0; i < 6; i++) {
    base->pp[i].ce = NULL;
    base->pp[i].cs = base->pp[i].ce+1;
    base->pp[i].kanji = J_ANK;
    base->pp[i].prev = (!i) ? NULL : &base->pp[i-1];/* pp ϰϳ */
    base->pp[i].next = (i == 1 || i == 5) ? NULL : &base->pp[i+1];
  }
}

void pause_cat(void)/*cb*/
{
  if (!cb->delay) return;
  if (cb->x >= cb->ws.x-8) { /* üǰ */
    kill(cb->c_pid, SIGTSTP);
    cb->f.pause = 1;
  } else if (cb->f.pause) {
    kill(cb->c_pid, SIGCONT);
    cb->f.pause = 0;
  }
}

void draw_idle(void)/*cb*/
{ /* åʳΥ٥ȤʤΥޥɽ */
  if (cb->delay) {
    pause_cat();
    if (cb->f.flow) cb->idle = cb->f.flow;
  } else if (cb->vf.wait || cb->vf.in) cb->idle = 4;
  else if (read_pos(cb->x, cb->y) || cb->button) cb->idle = 1;
  else cb->idle = 0;
  limit_xy();
  draw_cursor(cb->x, cb->y, cb->idle);
  cb->xo = cb->x;
  cb->yo = cb->y;
}

void sw_ws(int ws)/*cb*/
{
  int i, f;

  cb->f.off = 1;
  if ((f = cb->rline) < 0) cb->rline = -cb->rline;
  cb->ws.rrow = get_rrowp(ws);
  cb->rpos = ((i = cb->pn.nline - cb->ws.rrow) > 0) ? i * cb->rline : 0;
  set_ws(ct_ws[ws].row, ct_ws[ws].col);
  if (f > 0) {
    cb->step = ct_ws[ws].step;
    for (i = 0; cat.mode[i].p; i++) cat.mode[i].x = ct_ws[ws].dx[i];
    cb->bar = ct_ws[ws].bar;
    sw_vgamode(ws);
    init_frame();
  }
  cb->f.off = 0;
}

void set_ws(int row, int col)/*cb*/
{
  cb->ws.row = row * 16 / cb->rline;
  cb->ws.col = col;
  cb->ws.x = cb->ws.col * 8;
  cb->ws.y = cb->ws.row * 16;
}

void sw_vgamode(int ws)/*cb*/
{
  vramsetcrtc(ct_ws[ws].consoleMode);
}

void set_origin(ushort origin)/*cb*/
{ /* page-1 򥹥 */
  ct_orgp[1] = origin * LINE_LWORDS;
  ioctl(gl.ffd, FBIOCSETCRTC|FBIOCNOWAIT, ct_orgreq);
}

void layer_mode(int n)/*cb*/
{ /* ̥⡼ڤؤɽѥå */
  static char pal[3*16];
  int i;

  switch(n) {
  case 0:
    vramclear(0, 0, cb->ws.x, PAGE_LINES);
  case 2:  
    vramclear(0, LY, cb->ws.x, LY + PAGE_LINES);
    break;
  case 3:  
    ct_pali[ 0] = cb->color[0];
    ct_pali[ 1] = cb->color[1];
    ct_pali[ 2] = cb->color[2];
    
    ct_pali[ 3] = cb->color[0];
    ct_pali[ 4] = cb->color[1];
    ct_pali[ 5] = cb->color[2];
    
    ct_pali[30] = cb->color[0];
    ct_pali[31] = cb->color[1];
    ct_pali[32] = cb->color[2];
    
    ct_pali[27] = cb->color[3];
    ct_pali[28] = cb->color[4];
    ct_pali[29] = cb->color[5];
    
    ct_pali[24] = cb->color[3];
    ct_pali[25] = cb->color[4];
    ct_pali[26] = cb->color[5];
    
    ct_pali[ 6] = cb->color[6];
    ct_pali[ 7] = cb->color[7];
    ct_pali[ 8] = cb->color[8];
    
    ct_pali[33] = cb->color[9];
    ct_pali[34] = cb->color[10];
    ct_pali[35] = cb->color[11];
    
    ct_pali[42] = cb->color[12];
    ct_pali[43] = cb->color[13];
    ct_pali[44] = cb->color[14];
    
    ct_pali[12] = cb->color[15] * 8 / 8;
    ct_pali[13] = cb->color[16] * 8 / 8;
    ct_pali[14] = cb->color[17] * 8 / 8;
    
    ct_pali[15] = cb->color[15] * 5 / 8;
    ct_pali[16] = cb->color[16] * 5 / 8;
    ct_pali[17] = cb->color[17] * 5 / 8;
    
    ct_pali[18] = cb->color[15] * 11 / 8;
    ct_pali[19] = cb->color[16] * 11 / 8;
    ct_pali[20] = cb->color[17] * 11 / 8;
    
    ct_pali[21] = cb->color[15] * 12 / 8;
    ct_pali[22] = cb->color[16] * 12 / 8;
    ct_pali[23] = cb->color[17] * 12 / 8;
    for (i = 0; i < 3*16; i += 3) {
      pal[i] = ct_pali[i+2]<<4;
      pal[i+1] = ct_pali[i]<<4;
      pal[i+2] = ct_pali[i+1]<<4;
    }
    palette(0, pal);
    break;
  case 4:
    if (cb->y < MY) clear_sel();
    tomenu();
    vramclear(0, 0, cb->ws.x, PAGE_LINES);
    frommenu();
    break;
  }  
}

void set_bp(BASE *base)/*cb*/

{
  int i;

  gl.bp = base;
  cb->pn.nline = base->nline;
  cb->rpos = ((i = cb->pn.nline - cb->ws.rrow) > 0) ? i * cb->rline : 0;
}

int get_rrowp(int ws)/*cb*/
{
  int i;

  for (i = 0; ct_rline[i]; i++)
    if (ct_rline[i] == cb->rline) 
      return ct_ws[ws].rrowp[i];
  return 0;
}

void mask_row(void)/*cb*/
{
  static uint buff[LINE_LWORDS];
  uint *addr;
  int i;

  if (!*buff) for (i = 0; i < LINE_LWORDS; i++) buff[i] = 0xaaaaaaaa;
  for (i = 0; ct_rline[i]; i++)
    if (ct_rline[i] == cb->rline) break;
  if (!(i = ct_ws[gl.ws].mask[i])) return;
  for (addr = get_fb1(0, ct_ws[gl.ws].row*16-1); i; i--, addr -= LINE_LWORDS)
    memcpy(addr, buff, LINE_BYTES);
}  
