#include "cb.h"
GLOBAL 	 gl;
CB *cb;
static void usage(void)
{
  fprintf(stderr, "Usage: cb [<files...>] -A -a -c -t [-s -p? -d??]\n");
  fprintf(stderr, "Version: ");
  fwrite(&gl.version[4], 1, 5, stderr);
  fprintf(stderr, "\n");
  exit(1);
}

int main(int argc, char *argv[])/*cb*/
{
  int i, cons0, wid = 0, magic = X_INIT, a = 0;
  char *cp = NULL;
  struct termio otty;
  struct stat st;

  conf();
  if ((i = ioctl(fileno(stdin), TCGETA, &otty)) && 
      ioctl(fileno(stdout), TCGETA, &otty) && argc == 1) filter();
  if ((magic = check_cb()) == X_OLD) {
    fprintf(stdout, "cb: tty7: Not available\n");
    exit(1);
  }
  if (argc == 1)
    if (i) {
      if (magic == X_INIT || cb->vf.wait || cb->delay) {
	if (magic != X_INIT && (cb->vf.wait || cb->delay)) 
	  fprintf(stderr, "cb: Can't access cb\n");
	shmdt((char*)cb);
	if (get_vactive() == 7) {
	  fprintf(stderr, "cb: Can't execute -t\n");
	  exit(1);
	}
	gl.curr = getpid();
	fork_cb();
	cp = "-";
	magic = X_INIT;
      }
    } else if (magic == X_ACTIVE || magic == X_BUSY) {
      if (getuid()) setuid(0);
      if (cb) shmdt((char*)cb);
      set_vactive(8);
      exit(0);
    } else cp = NULL;
  else
    while (*++argv)
      if (**argv == '-')
	switch((*argv)[1]) {
	case 'a':
	  a = 1;
	  break;
	case 'A':
	  a = 2;
	  break;
	case 'b':
	  if (cb) shmdt((char*)cb);
	  sleep(15*60);
	  while (1) putchar(7);
	  break;
	case 't':
	  if (cb) shmdt((char*)cb);
	  if (get_vactive() == 7) {
	    fprintf(stderr, "cb: Can't execute -t\n");
	    exit(1);
	  }
	  gl.curr = getpid();
	  do {
	    if (i) {
	      fork_cb();
	      cp = "-";
	    } else if (argc == 2) continue;
	    magic = X_INIT;
	  } while (0);
	  break;
	case 'c':
	  read_fifo();
	  break;
	case 'p':
	  if (!(*argv)[2]) {
	    fprintf(stderr, "cb: -p?: No palette number\n");
	    exit(1);
	  } else gl.n_pal = (*argv)[2];
	  break;
	case 's':
	  gl.ws = 0;
	  break;
	case 'd':
	  switch((wid = atoi(&argv[0][2]))) {
	  case 16:
	  case 18:
	  case 20:
	  case 24:
	    gl.wid = wid;
	    break;
	  default:
	    fprintf(stderr, "cb: -d%s: Invalid width [16/18/20/24]\n"
		    ,&argv[0][2]);
	    exit(1);
	  }
	  break;
	default:
	  usage();
	  break;
	}
      else cp = *argv;
  if (a) {
    if (magic == X_ACTIVE || magic == X_BUSY) shmdt((char*)cb);
    rexec_cb(a);
    if (a == 2) exit(0);
    magic = X_INIT;
    gl.curr = 0;
  }
  if (!gl.curr && magic == X_BUSY) {
    gl.curr = getpid();
    if (cp && *cp != '-') fprintf(stderr, "cb: Can't access cb\n");
  }
  cons0 = get_vactive();
  if (gl.curr) {
    setuid(0);
    if (!cp) {
      fprintf(stderr, "cb: No filename\n");
      exit(1);
    } else if (*cp == '-') magic = X_EXEC;
    else if (stat(cp, &st) < 0) {
      fprintf(stderr, "cb: %s: %s\n", cp, strerror(ENOENT));
      exit(1);
    } else if (S_ISDIR(st.st_mode)) {
      fprintf(stderr, "cb: %s is directory\n", cp);
      exit(1);
    } else if (!(st.st_mode & S_IROTH)) {
      fprintf(stderr, "cb: %s: %s\n", cp, strerror(EACCES));
      exit(1);
    }
  } else if (magic == X_INIT && get_vactive() != 8) {
    /* üڤΥ stdin ..  tty8 Ѥ dup */
    if (fork()) exit(0);
    close(0);
    close(1);
    close(2);
    setsid();
    if (open("/dev/tty8", O_RDWR, 0) == -1) {
      perror("/dev/tty8");
      exit(2);
    }
    dup(0);
    dup(0);
    set_vactive(8);
    while (get_vactive() != 8) usleep(10000);
  }
  if (!gl.curr && getuid()) setuid(0);
  switch(magic) {
  case X_STAT:
    exit(1);
    break;
  case X_EXEC:
    exec_cb("-", cons0);
    break;
  case X_ERR:
    system("cb -a");
    break;
  case X_BUSY:
    if (cb) shmdt((char*)cb);
  case X_INIT:
    exec_cb(cp, cons0);
    break;
  case X_ACTIVE:
    jump_cb((cp) ? M_FILE : M_PIPE, cp);
    exit(0);
  }
  return(0);
}

