#ifndef	_CB_H
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <time.h>
#include <termios.h>
#include <unistd.h>
#include <malloc.h>
#include <dirent.h>
#include <setjmp.h>
#include <sys/kd.h>
#include <sys/vt.h>
#include <sys/time.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <sys/mman.h>
#if 0
#include <asm/io.h>
#endif
#include <asm/page.h>
#include <linux/fb.h>
#include <linux/fbioc.h>
#include <linux/tmouse.h>
/* #include <linux/mm.h> */
#include <linux/krom.h>

#define TOWNS_MOUSE		0		/*  TOWNS ޥ(1999/7/21 ɲ) */
#define BUS_MOUSE		1		/* Хޥߴ (1999/7/21 ɲ) */

#define WS_COL0			80
#define WS_ROW0			30
#define WS_COL1			96
#define WS_ROW1			32

#define LINE_BYTES 		0x200 		/* bytes/line */
#define PAGE_BYTES 		0x40000		/* bytes/page */
#define PAGE_LINES        	512		/* lines/page */
#define LINE_LWORDS		(LINE_BYTES/4) /* longwords/line */
#define PAGE_LWORDS		(PAGE_BYTES/4) /* longwords/page */
#define BIT_PAGE		18		/* PAGE_BYTES-bit */
#define ROW_LINES		18		/* lines/row */
#define USEC			10000		/* busy-loop (10msec) */
#define MX			342		/* ޥ(x) */
#define MY			48	 	/* ޥ(y) */
#define LY			512		/* 쥤κǽ y ɸ */
#define OY			(512+512)	/* VRAM κǽ y ɸ */
#define BX			28		/* Сü */
#define LBX			32		/* ե̾ɽ */
#define SHMCB_SIZE		0x1000		/* ( > sizeof(CB)) */
#define T_SIZE 			0x10000		/* malloc ñ */
#define	TABI			(char*)0xffffffff
#define DL			0x7f
#define EC			0x1b

#define K16FONT_BASE  		(0xE3000000-0xC0000000)
#define ANKFONT_BASE  		(K16FONT_BASE + 0x3d800)
#define ANK_FONT		(ANKFONT_BASE-K16FONT_BASE)
#define ANK_ADDR		(ANK_FONT/PAGE_SIZE*PAGE_SIZE)
#define ANK_OFFS		(ANK_FONT%PAGE_SIZE)
#define ANK_SIZE		(KROM_SIZE-ANK_ADDR)
#define VRAM_SIZE		0x80000

#define N_SEL			72		/* ٥Ȱ־ */
#define N_STR			128		/* malloc ʸĹ */

#define N_TTY_			9		/* tty1  tty9 */
#define N_PAL			6		/* ꥳɿ */
#define N_MC			2		/* ޥ롼ץå */
#define M_ACTIVE		0x00cb073e	/* ư */
#define M_EXIT			0x01000000	/* WS ڤؤ */
#define M_FILE			0x02000000	/* ե*/
#define M_PIPE			0x04000000	/* stdin */
#define M_INIT			0x08000000	/* ¾üκǽ cb */
#define M_TTY			0x10000000	/* tty8 ؤؤ */
#define M_FORK			0x20000000	/* ǽεư stdin */
#define M_MASK			0xff000000	/* M_ACTIVE ޥ */

#define VERSION 		(M_ACTIVE&0xfff)/* version No. */
#define IPC_CB			VERSION		/*  IPC-key No. */

#define check_active()		((cb->magic & ~M_MASK) == M_ACTIVE)
#define check_magic(m)		((cb->magic & M_MASK) & (m))
#define set_magic(m)		(cb->magic |= (m))
#define res_magic(m)		(cb->magic &= ~(m))

#define get_addr(x, y)		((x)/2+(y)*LINE_BYTES)       /* ɥ쥹׻ */
#define get_fb1(x, y)		((uint*)(get_addr(x,y)+gl.fb))  /* TOWNS-fb */
#define get_fb2(addr)		((uint*)((uint)(addr)+gl.fb))   /* TOWNS-fb */
#define get_bf1(x, y)		((uint*)(get_addr(x,y)+gl.bf))  /* VRAM */
#define get_bf2(addr)		((uint*)((uint)(addr)+gl.bf))   /* VRAM */
#define get_addr1(x, y, addr)	((uint*)(get_addr(x,y)+(uint)addr))/* 'addr' */
#define BORDER 			(((cb->ws.row*cb->rline/16+1)*16-MY)/2)
#define limit(n,l,u)		n=((n)<(l)?(l):((n)>(u)?(u):(n)))/* ϰ */

#define memcpy_fromvram(d,s,n) 	memcpy(d, s, n)
#define memcpy_tovram(d,s,n) 	memcpy(d, s, n)
#define get_conspal()		palette(1, NULL)
#define set_conspal()		palette(0, NULL)
#define is_euckana_1_byte(n)	(n == 0x8e)
#define is_euckana_2_byte(n)	(0xa1<=n && n<=0xdf)
#define is_euc_1_byte(n)	(n>=0xa1 && n<=0xff)
#define is_euc_2_byte(n)	(n>=0xa1 && n<=0xff)
#define is_sjis_1_byte(n)	((n>=0x81 && n<=0x9f) || (n>=0xe0 && n<=0xea))
#define is_sjis_2_byte(n)	(n>=0x40)
#define is_sjiskana(n)		(n >= 0xa1 && n <= 0xdf)
#define is_sjis(n)		(n >= 0x81 && n <= 0x9f && n != 0x8e)

#if defined __GLIBC__ && __GLIBC__ >= 2
typedef unsigned char unchar;
#endif /* defined __GLIBC__ && __GLIBC__ >= 2 */

enum {
  AT,
  SH, SX, EX, ET, EQ, AK, BL, BS,
  HT, LF, HM, CL, CR, SO, SI, DE,
  D1, D2, D3, D4, NK, SN, EB, CN,
  EM, SB,
  
  /* user customize K_CRT  K_CE */
  
  K_CRT=1, K_WS, K_PAL, K_WID, K_LIST, 
  K_DIR, K_FILE, K_DU, K_RDU, K_GREP, 

  K_RGREP, K_FIFO, K_RFIFO, K_MENU, K_HELP, 
  K_RHELP, K_TTY, K_LOG, K_EXIT, K_MCDEF, 

  K_MCEND, K_MCRUN, K_SUSP, K_QUIT, K_CANSEL, 
  K_CLEAR, K_KNEXT, K_KPREV, K_HEAD, K_TAIL, 

  K_BACK, K_FORW, K_KRT, K_KLT, K_KUP, 
  K_KDN, K_CS, K_CE, K_SYS, K_SYS0, 

  K_SYS1, K_PF, 
  
  K_SH=K_PF+13, K_SX, K_EX, K_ET, K_EQ, K_AK, K_BL, K_BS,
  K_HT, K_LF, K_HM, K_CL, K_CR, K_SO, K_SI, K_DE,
  K_D1, K_D2, K_D3, K_D4, K_NK, K_SN, K_EB, K_CN,
  K_EM, K_SB,

  K_SPC, 	/* ' ' */
  K_b,		/* 'b' */
  K_F,		/* 'F' */
  K_f,		/* 'f' */
  K_DL,		/* DL */
  K_EC,		/* EC */
  K_EC1,	/* EC<<8 */
  K_RT, 	/*  */
  K_LT,		/*  */
  K_UP,		/*  */
  K_DN,		/*  */
  K_PREV,
  K_NEXT,
  K_SCp,
  K_SCn,
  K_TAB,

  K_SC_PF,	/* SHIFTCTRLPF */

  K_0=K_SC_PF+11,/* '0' */
  K_1,		/* '1' */
  K_2,		/* '2' */
  K_3,		/* '3' */
  K_4,		/* '4' */
  K_5,		/* '5' */
  K_6,		/* '6' */
  K_7,		/* '7' */
  K_8,		/* '8' */
  K_9,		/* '9' */
  K__0,		/* '.' */
  K__1,		/* ',' */
  K__2,		/*  */
  K__3,		/*  */
  K__4,		/*  */
  K__5,		/*  */
  K__6,		/*  */
  K__7,		/*  */
  K__8,		/*  */
  K__9,		/*  */
  K_S_PF,
  K_C_PF=K_S_PF+13,

  K_SC_RET=K_C_PF+13,

  PF=0x80,
  UP=PF+18, LT, DN, RT, PREV, NEXT, TAB,

  S_PF=PF+0x20,
  S_EC=S_PF+13, S_DL, S_CR, S_RET, S_SPC, 
  S_UP, S_LT, S_DN, S_RT, S_PREV, S_NEXT,

  C_PF=PF+0x40,
  C_EC=C_PF+13, C_DL, C_CR, C_RET, C_SPC, 
  C_UP, C_LT, C_DN, C_RT, C_PREV, C_NEXT,

  SC_PF=PF+0x60,
  SC_EC=SC_PF+13, SC_DL, SC_CR, SC_RET, SC_SPC, 
  SC_UP, SC_LT, SC_DN, SC_RT, SC_PREV, SC_NEXT,
  SC_p, SC_n,	

  E_CLEAR=1, E_HEAD, E_TAIL, E_LEFT, E_RIGHT, E_LABEL, 
  E_SCROLL=7, /* cat.c:" < > "(mode[7]) */
  E_CRT, E_LIST, E_DU, 

  E_GREP, E_FIFO, E_MENU, E_RDU, E_RFIFO, 
  E_BACK, E_FORW, E_UP, E_DN, E_NULL, 

  E_HELP, E_CR, E_QUIT, E_SUSP, E_SKIP, 
  E_RGREP, E_DIR, E_FILE, E_NEXT, E_PREV, 

  E_SC_RET, N_MODE, C_BROW, C_CUT, C_EXEC,
  C_BIN, C_PIPE, C_DU, C_DIR, C_FILE,

  C_TAR, C_LHA, C_UNZIP, C_LABEL, C_SKIP,
  C_CRT, C_WS, C_PAL, C_WID, C_LIST,

  C_LDIR, C_LFILE, C_GREP, C_MENU, C_HELP,
  C_TTY,C_LOG, C_SYS, C_SYS0, C_SYS1,

  T_DIR,T_FILE, T_DU, T_TAR, T_GREP,
  T_SKIP,T_LHA, T_UNZIP, T_PIPE, T_HELP,

  TT_GREP, J_ANK, J_JIS, J_SJIS, J_EUC,
  J_BIN, J_UP, J_SPC, S_INIT, S_MOVE,

  S_FORW, S_BACK, S_PIN, V_SET, V_RES,
  V_NOT, N_PUSH, N_PULL, X_BUSY, X_STAT,

  X_EXEC, X_ERR, X_INIT, X_ACTIVE, X_OLD,
};

/* ־ */
typedef struct PN {
  int y;		/* ޥ */
  int nline, pos;	/* եԿ16, ߰ */
} PN;

/* ־¸ꥹ */
typedef struct LIST {
  union {
    PN pn;		/* ־ */
    char color[3*N_PAL];/* ѥå */
  } l;
  char name[256];	/* ե̾ */
  struct LIST *left;	/* Ρ */
  struct LIST *right;	/* Ρ */
} LIST;
  
/* ԥݥ */
typedef struct PP {
  struct PP *prev;	/*  */
  struct PP *next;	/*  */
  char *cs, *ce;	/* ԤƬ֡ */
  char *str;		/* ԡʸ */
  int tell, cut, kanji;	/* ڤʬե֡ */
} PP;

/* ɽե */
typedef struct {
  int nline, size;	/* Կ16 */
  char *text;		/* ƥ */
  PP pp[6];		/* ԥݥ */
} BASE;

/* ¾üΥ */
typedef struct CONT {
  FILE *fd;		/* ̾դѥ */
  PP *pp;		/* ȥݥ */
  int row;
  int pid;		/* ץ */
  int cons;		/* ü */
  BASE *base;		/* ɸ */
  struct CONT *next;	/*  */
} CONT;

/* ҥץ */
typedef struct CHILD {
  int argc;		/* ʸ */
  char **argv;		/* ʸ */
  char *ext;		/* ĥ */
  int exec;		/* ¹ԤΤ߻ */
  struct CHILD *next;	/*  */
} CHILD;

/* åоݥե饰 */
typedef struct {
  uint bs	: 1;	/* ֥饦GREP ǤΰʸƬڡʬ */
  uint dir	: 1;	/* DU Υǥ쥯ȥ(ǥå) */
  uint cld	: 1;	/* åˤե(ҥץư) */
  uint grep	: 2;	/* ⡼ */
  uint arc	: 3;	/* Ÿ */
  uint shift	: 5;	/* ¾üΥץǤ base ź 16 */ 
  uint lb	: 5;	/* ⡼ɥ٥ No */
} FLAG;

/* ץֶͭ */
typedef struct {
  volatile uint magic;	/* cbưޤ¾üΥե뻲Ȼå */
  uint origin : 9;	/* 륢ɥ쥹 (0 < origin < 512) */
  int rline, rpos;	/* ǽڡ */
  int num, max;  	/* MY ϰϤǤΥ٥ȿ */
  int bar; 		/* СĹ */
  int step; 		/* ®Ĵƥå */
  int tty, cons;	/* cb ü, ü */
  int x,y, xo,yo;	/* ޥ֡ʿˡʵ*/
  int mouse, idle;	/* ޥư̡ޥ No. */
  int protocol;		/* ޥץȥ(1999/7/21 ɲ) */
  int push;		/* ֤ɽܥ No. */
  int s_f;		/*  */
  int c_f;		/* ߤɽ⡼ */
  int s_pid;		/* ¾üΥץ ID */
  int r_pid;		/* FIFO read ץ ID */
  int n_pal;		/* PAL  */
  int loop;		/* ٱ롼(Ϥ) */
  int saver;		/*  */
  int input;
  volatile int l_pid;	/* stderr ¸ץ ID */
  volatile int w_pid;	/* FIFO write ץ ID */
  volatile int event;	/* ٥ No. */
  volatile int k_pid;	/* ϥץ ID */
  volatile int d_pid;	/* եɤ߹ߥץ ID */
  volatile int c_pid;	/* ץ ID */
  volatile int delay;	/* Ĵ(usleep, 颪busy-loop) */
  volatile int drag;	/* ̥ɥåΥɥåȥ */
  volatile int button;	/* ޥܥξ */
  volatile time_t ll;	/* ַ¬ (for saver) */
  struct {
    volatile uint busy	: 1;	/*  */
    volatile uint stop	: 1;	/* üڤؤݤΥ */
    volatile uint key	: 1;	/* ʸ */
    volatile uint wait	: 1;	/* եɤ߹ */
    volatile uint in	: 1;
    volatile uint jmp	: 2;	/* set_jmp  */
    volatile uint config: 2;	/* cb????.config 줿 */
    volatile uint vf	:16;	/* ƥ */
  } vf;
  struct {
    uint lack	: 1;	/* Կʬʤ */
    uint pause	: 1;	/*  */
    uint blanked: 1;	/* вƯ */
    uint man	: 1;	/* man (ʤ) */ 
    uint right	: 1;	/* åǥե򤷤 */
    uint off	: 1;	/* ɽ */
    uint pin	: 1;
    uint macro  : 2; 	/* 1:, 2:Ѥ, 3:¹ */
    uint flow	: 2; 	/* ® */
    uint cons	: 4;	/* ڤؤü No. */
    uint ff	:16;	/* ƥ */
  } f;
  FLAG ff;
  unchar tag[128];	/* ι */
  char pathname[128];	/* ¾üΥե̾ */
  char errormes[128];	/* stderr  */
  char procname[128];	/* fifo ϥץ proc ̾ */
  char color[3*N_PAL];	/* ѥåȥ */
  struct {
    int xs, ys, xe, ye;	/* ٥Ȥ */
    int c;		/* ϰ˥ޥ뤬 1 ˥å */
  } sel[N_SEL];		/* N_SELսޤ */
  struct {
    int col, row;	/* ʸʸ */
    int x, y;		/* ɥåȿĥɥåȿ */
    int rrow;		/* ɽԿ */
  } ws;
  struct {
    unchar str[128];	/* ʸ */
    int x, y;		/*  */
    int i;		/* str θ߰ */
    int f;		/* ǥե饰 */
    int k_n;
    int c_f;
  } ky;
  PN pn;		/* Ȱ־ */
  union {
    FILE *fd;
    PP *pp;
    int i;
  } in;
  struct {
    uint ws	: 1;
    uint wid	: 5;
  } crt;
} CB;

typedef struct {
  int ky;		/* ǽ HELP ư */
  int z;		/* ॵ */
  int file;		/* ե륿ɽ */
  int code_1, code_2;	/* 1,2Х */
  int fb, bf; 		/* TOWNS-fb(512KB)Хåե(256KB) */
  int curr;		/* ȵư */
  int uid;		/* ¥桼 ID */
  int n_pal, ws;	/* */
  volatile int loop;		/* ٱ롼 */
  int kanjimode;	/* ưü */
  int old;		/* üɥ饤Фˤѥå̤ݡ */
  int kfd, ffd;		/* ե뵭һ(/dev/krom, /dev/fb) */
  int len;		/* ե̾Ĺ */
  int row;
  uint *end;
  char *note, *ctrl;	/* ܡȥ륳 */
  char *editor;		/* cb??.config Խǥ */
  char color[3*3];	/* ѥåȥ */
  char pathname[256];	/* ե̾ */
  char *version;	/* version */
  char *help;		/* 饤إʸ */
  char *config;		/* cb???.config եѥ */
  char err[256];	/* LOG ¸ե̾ */
  char fifo[2][256];	/* ̾դѥ̾ */	
  char log[1000];	/* cb  stderr  */
  char c_str[24];
  uint convdata[256];	/* vram ɽʸѥ */
  BASE base[1], *bp;	/* ɽ base ݥ */
  struct termios text_termio; /* 󥽡 */
  struct termios cb_termio; /* cb  */	
  int wid, tfd;
} GLOBAL;

extern GLOBAL 	gl;
extern CB *cb;
#include "cb.P"		/* ץȥ */
#endif /* _CB_H */
#define _CB_H

