#include "cb.h"
#include "key.h"
KY ky;
static char ky_bs[] = " ";
static char ky_num[] = "0123456789abcdef";
static char ky_pal[] = "\033]P??0?0?0";
static char ky_echo[] = "\033c";
static char ky_ext[] = {
  EC,DL,CR,CR,' ','\0'
};
static unchar ky_addr[] = { /* 󥳡 */
  0x80,0x5d,0x5e,0x5f,0x60,0x61,0x62,0x63, /* PF1  PF12 */
  0x64,0x65,0x66,0x69,0x5b,0x01,0x0f,0x1d,
  0x73,0x35,0x4d,0x4f,0x50,0x51,0x6e,0x70,
  0x10,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
  
  0x1b,0x1e,0x2e,0x2c,0x20,0x13,0x21,0x22, /* @  O */
  0x23,0x18,0x24,0x25,0x26,0x30,0x2f,0x19,
  
  0x1a,0x11,0x14,0x1f,0x15,0x17,0x2d,0x12, /* P  _ */
  0x2b,0x16,0x2a,0x1c,0x0e,0x29,0x0d,0x34,
  
  0x0b,0x02,0x03,0x04,0x05,0x06,0x07,0x08, /*    ? */
  0x09,0x0a,0x28,0x27,0x31,0x0c,0x32,0x33,
  
  '\0'
};
static int ky_tab[] = {
  -1,
  
  /* user customize K_CRT  K_CE */
  
  't',	/* K_CRT */
  's',	/* K_WS */
  'l',	/* K_PAL */
  'w',	/* K_WID */
  D4,		/* K_LIST */
  'r',	/* K_DIR */
  'e',	/* K_FILE */
  'u',	/* K_DU */
  'U',	/* K_RDU */
  D3,		/* K_GREP */
  'p',	/* K_RGREP */
  '|',	/* K_FIFO */
  '!',	/* K_RFIFO */
  '*',	/* K_MENU */
  BS,		/* K_HELP */
  'h',	/* K_RHELP */
  'y',	/* K_TTY */
  'g',	/* K_LOG */
  EX,		/* K_EXIT */
  (CN<<8)+'(',/* K_MCDEF */
  (CN<<8)+')',/* K_MCEND */
  (CN<<8)+'e',/* K_MCRUN */
  SB,		/* K_SUSP */
  'q',	/* K_QUIT */
  BL,		/* K_CANSEL */
  CL,		/* K_CLEAR */
  SN,		/* K_KNEXT */
  (EC<<8)+'v',/* K_KPREV */
  (EC<<8)+'<',/* K_HEAD */
  (EC<<8)+'>',/* K_TAIL */
  '<',	/* K_BACK */
  '>',	/* K_FORW */
  AK,		/* K_KRT */
  SX,		/* K_KLT */
  DE,		/* K_KUP */
  SO,		/* K_KDN */
  SH,		/* K_CS */
  EQ,		/* K_CE */
  'S',	/* K_SYS */
  'm',	/* K_SYS0 */
  'M',	/* K_SYS1 */
  
  PF,
  PF+1,	/* K_PF+1 */
  PF+2,
  PF+3,
  PF+4,
  PF+5,
  PF+6,
  PF+7,
  PF+8,
  PF+9,
  PF+10,
  PF+11,
  PF+12,
  /* control code K_SH  K_SB */

  SH, SX, EX, ET, EQ, AK, BL, BS,
  HT, LF, HM, CL, CR, SO, SI, DE,
  D1, D2, D3, D4, NK, SN, EB, CN,
  EM, SB,
  
  /* others K_SPC  K_EC2D */
  
  ' ',	/* K_SPC */
  'b',	/* K_b */
  'F',	/* K_F */
  'f',	/* K_f */
  DL,		/* K_DL */
  EC, 	/* K_EC */
  EC<<8, 	/* K_EC1 */
  RT,		/* K_RT */
  LT,		/* K_LT */
  UP,		/* K_UP */
  DN,		/* K_DN */
  PREV,	/* K_PREV */
  NEXT,	/* K_NEXT */
  'k', /* K_SCp */
  'j', /* K_SCn */
  TAB,	/* K_TAB */
  SC_PF,
  SC_PF+1,
  SC_PF+2,
  SC_PF+3,
  SC_PF+4,
  SC_PF+5,
  SC_PF+6,
  SC_PF+7,
  SC_PF+8,
  SC_PF+9,
  SC_PF+10,
  '0',	/* K_0 */
  '1',	/* K_1 */
  '2',	/* K_2 */
  '3',	/* K_3 */
  '4',	/* K_4 */
  '5',	/* K_5 */
  '6',	/* K_6 */
  '7',	/* K_7 */
  '8',	/* K_8 */
  '9',	/* K_9 */
  ',',	/* K__0 */
  '.',	/* K__1 */
  -1,	/* K__2 */
  -1,	/* K__3 */
  -1,	/* K__4 */
  -1,	/* K__5 */
  -1,	/* K__6 */
  -1,	/* K__7 */
  -1,	/* K__8 */
  -1,	/* K__9 */
  S_PF,
  S_PF+1,
  S_PF+2,
  S_PF+3,
  S_PF+4,
  S_PF+5,
  S_PF+6,
  S_PF+7,
  S_PF+8,
  S_PF+9,
  S_PF+10,
  S_PF+11,
  S_PF+12,
  C_PF,
  C_PF+1,
  C_PF+2,
  C_PF+3,
  C_PF+4,
  C_PF+5,
  C_PF+6,
  C_PF+7,
  C_PF+8,
  C_PF+9,
  C_PF+10,
  C_PF+11,
  C_PF+12,
  SC_RET,
  0,
};

void term_key(int dummy)/*cb*/
{
  if (!gl.curr) set_vactive(8);
  exit_key();
}

void segv_key(int dummy)/*cb*/
{
  cb->vf.jmp = 2;
  exit_key();
}

void exit_key(void)/*cb*/
{ /* ü򸵤ˤɤ */
  int i;

  if (ky.n_mc) {
    for (i = 0; i < ky.n_mc*2; i++) free(ky.mc[i]);
    free(ky.mc);
  }
  flush_key(ky.tfd);
  close(ky.tfd);
  close(ky.mfd);
  exit_cb(ky.echo);
}

void keyin(char *pathname)/*cb*/
{
  time_t ll;
  unchar *kp, *cp;
  int c, i, j, k_n, key, ii, c_pid;
  char errormes[256], editor[40];
  static unchar tbl[16*3];

  ky.tfd = open("/dev/console", O_RDWR);
  ioctl(ky.tfd, TIOCGWINSZ, &ky.ws);
  palette(1, tbl);
  ky.tab = ky_tab;
  ky.ext = ky_ext;
  ky.addr = ky_addr;
  ky.num = ky_num;
  ky.pal = ky_pal;
  ky.echo = ky_echo;
  ky.bs = ky_bs;
  init_chp(1, ky.tab, ky.first);
  if (gl.old) set_tbl(tbl);
  /* ץԤ */
  ky.mfd = open("/dev/mouse", O_RDONLY);
  pid_str(gl.c_str, cb->c_pid);
  c_pid = cb->c_pid;
  if (!gl.curr || pathname) while (!check_proc(gl.c_str)) loop(10000);
  else while (check_proc(gl.c_str) != 1) loop(10000);
  layer_mode(3);
  kill(cb->c_pid, SIGCONT);
  if (gl.ky) {
    wait_susp();
    cp = set_comm(ky.comm, ky.tab[K_MENU]);
    *cp++ = ky.tab[K_1];
    *cp++ = ky.tab[K_CR];
    *cp++ = ky.tab[K_CR];
    *cp = 0;
  }
  unblank_screen();
  for (ii = M_ACTIVE, key = 0, kp = NULL; ;printtime(0)) {
    if (!cb->k_pid) {
      cb->c_pid = 0;
      term_key(0);
    }
    if (!cb->c_pid) cb->c_pid = c_pid; /* unknown error */
    if (cb->w_pid && *cb->procname && check_proc(cb->procname) < 0) {
      kill(cb->c_pid, SIGCONT);
      wait_susp();
    }
    time(&ll);
    if (cb->ky.k_n == K_WS) {
      cb->ky.k_n = 0;
      kill(cb->c_pid, SIGCONT);
      continue;
    } else if (cb->ky.k_n == K_SC_PF+9 || cb->ky.k_n == K_SC_PF+10) {
      unblank_screen();
      if (cb->delay) clear_delay();
      if (cb->ky.k_n == K_SC_PF+9) {
	for (c = 0; cb->errormes[c] != ')'; c++) ; 
	c += 2;
      } else c = 0;
      strcpy(errormes, &cb->errormes[c]);
      *cb->errormes = 0;
      go_sys(errormes, NULL, cb->ky.k_n == K_SC_PF+9);
      cb->ky.k_n = 0;
      if (gl.old) set_tbl(tbl);
      continue;
    }
    if (cb->f.cons) {
      wait_susp();
      go_cons(cb->f.cons);
      cb->f.cons = 0;
    }
    if (cb->f.macro == 3 && ky.up) {
      if (!(c = *ky.up++)) {
	ky.up = NULL;
	key = 0;
      } else key = mask_key(key)|c;
      wait_susp();
      if (ky.n_mc) {
	if ((i = ky.up - ky.macro - 1) < ky.n_mc) {
	  ky.mc[i]->y = cb->y;
	  ky.mc[i]->nline = cb->pn.nline;
	  ky.mc[i]->pos = cb->pn.pos;
	} else {
	  for (i = j = 0; i < ky.n_mc; i++) {
	    if (ky.mc[i]->y != ky.mc[i+ky.n_mc]->y) {
	      j++;
	      ky.mc[i+ky.n_mc]->y = ky.mc[i]->y;
	    }
	    if (ky.mc[i]->nline != ky.mc[i+ky.n_mc]->nline) {
	      j++;
	      ky.mc[i+ky.n_mc]->nline = ky.mc[i]->nline;
	    }
	    if (ky.mc[i]->pos != ky.mc[i+ky.n_mc]->pos) {
	      j++;
	      ky.mc[i+ky.n_mc]->pos = ky.mc[i]->pos;
	    }
	  }
	  if (j) ky.n_err = 0;
	  else if (++ky.n_err >= N_MC) {
	    ky.n_err = 0;
	    cb->f.macro = 0;
	    ky.up = NULL;
	    key = 0;
	    for (i = 0; i < ky.n_mc; i++) {
	      ky.mc[i+ky.n_mc]->y = 0;
	      ky.mc[i+ky.n_mc]->nline = 0;
	      ky.mc[i+ky.n_mc]->pos = 0;
	    }
	  }
	}
      }
    } else {
      if (*ky.comm && !kp) {
	kp = ky.comm;
	key = 0;
      }  
      if (kp)
	if (*kp) {
	  key = mask_key(key)|*kp++;
	  wait_susp();
	  draw_idle();
	} else {
	  *ky.comm = 0;
	  kp = NULL;
	  continue;
	}
      else if (!*ky.comm && poll_key(10000)) {
	if (ii == M_ACTIVE) {
	  if (!gl.curr || pathname) draw_idle();
	  ii = 0;
	}
	if (ll - cb->ll > cb->saver) blank_screen();
	continue;
      } else {
	unblank_screen();
	switch(cb->ky.k_n) {
	case K_FORW:
	case K_BACK:
	case K_CRT:
	case K_LIST:
	case K_DU:
	case K_RDU:
	case K_GREP:
	case K_RGREP:
	case K_FIFO:
	case K_RFIFO:
	case K_MENU:
	case K_SUSP:
	case K_TAB:
	case K_QUIT:
	case K_HEAD:
	case K_TAIL:
	case K_CANSEL:
	case K_F:
	case K_f:
	  key = ky.tab[cb->ky.k_n];
	  cb->ky.k_n = 0;
	  break;
	default:
	  if (cb->ky.k_n >= K_0 && cb->ky.k_n <= K_9) {
	    key = ky.tab[cb->ky.k_n];
	    cb->ky.k_n = 0;
	  } else if ((c = read_key(ky.tfd)) != 0) {
	    key |= c;
	    c = mask_ctl(key);
	    if (tabchrstr(ky.tab, c, TABI)-1 >= K_0)
	      switch(cb->c_f) {
	      case C_CRT:
	      case C_LIST:
	      case C_MENU:
	      case C_PAL:
	      case C_WID:
	      case C_TTY:
	      case C_SYS:
	      case C_SYS0:
	      case C_SYS1:
		cp = set_comm(ky.comm, c);
		*cp++ = ky.tab[K_CR];
		*cp = 0;
		continue;
		break;
	      }
	    if (tabchrstr(ky.tab, c, TABI)-1 == K_EC || 
		(tabchrstr(ky.first, c, NULL) && 
		 !tabchrstr(ky.first, mask_1(key)>>8,NULL)))
	      key = c;
	    if (mask_ctl(key) && cb->f.macro == 1) {
	      if (ky.up == ky.macro + 255) {
		*ky.up = 0;
		cb->f.macro = 0;
	      } else
	        *ky.up++ = mask_ctl(key);
	    }
	  } else if (!cb->vf.key) continue;
	  break;
	}
      }
    }
    if (!key) continue;
    if ((k_n = tabchrstr(ky.tab, mask_ctl(key), TABI)-1) < K_0)
      k_n = tabchrstr(ky.tab, key, TABI)-1;
    switch(k_n) {
    case K_CANSEL:
      if (!cb->vf.in && gl.curr && *cb->tag == 0xa0 && !cb->ff.grep) ;
      else cansel(ky.tab[k_n]);
      break;
    case K_RHELP:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_1];
      *cp++ = ky.tab[K_F];
      *cp = 0;
      break;
    case K_PF+7:
    case K_HELP:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_1];
      *cp++ = ky.tab[K_CR];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+1:
    case K_WS:
      cp = set_comm(ky.comm, ky.tab[K_CRT]);
      *cp++ = ky.tab[K_1];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+2:
    case K_PAL:
      cp = set_comm(ky.comm, ky.tab[K_CRT]);
      *cp++ = ky.tab[K_2];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+10:
    case K_WID:
      cp = set_comm(ky.comm, ky.tab[K_CRT]);
      *cp++ = ky.tab[K_3];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+8:
    case K_TTY:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_2];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+9:
    case K_LOG:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_3];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_SYS:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_4];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+11:
    case K_SYS0:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_4];
      *cp++ = ky.tab[K_CR];
      *cp++ = ky.tab[K_1];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_PF+12:
    case K_SYS1:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_4];
      *cp++ = ky.tab[K_CR];
      *cp++ = ky.tab[K_2];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_EXIT:
      cp = set_comm(ky.comm, ky.tab[K_MENU]);
      *cp++ = ky.tab[K_6];
      *cp = 0;
      break;
    case K_PF+6:
    case K_GREP:
    case K_RGREP:
      if (cb->ff.grep % 2 || cb->f.pin) {
	key = 0;
	continue;
      }
      cb->push = E_GREP;
      cb->event = (k_n == K_RGREP) ? E_RGREP : E_GREP;
      draw_button(N_PUSH, 1);
      cb->vf.key = 1;
      send_sig();
      wait_susp();
      init_blink();
      *ky.comm = 0;
      read_vfkey();
      break;
    case K_PF+4:
    case K_FILE:
      cp = set_comm(ky.comm, ky.tab[K_LIST]);
      *cp++ = ky.tab[K_2];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_MCDEF:
      cb->f.macro = 1;
      ky.up = ky.macro;
      for (i = 0; i < 256; i++) ky.macro[i] = 0;
      break;
    case K_MCEND:
      if (cb->f.macro == 1) {
	*--ky.up = 0;
	*--ky.up = 0;
	cb->f.macro = 2;
	if (ky.n_mc) {
	  for (i = 0; i < ky.n_mc*2; i++) free(ky.mc[i]);
	  free(ky.mc);
	  ky.n_mc = 0;
	}
      }
      break;
    case K_MCRUN:
      if (*ky.macro) {
	if (cb->f.macro == 1) {
	  if (ky.n_mc) {
	    for (i = 0; i < ky.n_mc*2; i++) free(ky.mc[i]);
	    free(ky.mc);
	  }
	  ky.n_mc = ky.up-ky.macro-2;
	  ky.mc = (MC**)malloc(sizeof(MC*)*ky.n_mc*2);
	  for (i = 0; i < ky.n_mc*2; i++) 
	    ky.mc[i] = (MC*)calloc(sizeof(MC), 1);
	}
	cb->f.macro = 3;
	ky.up = ky.macro;
      }
      break;
    case K_PF+3:
    case K_DIR:
      cp = set_comm(ky.comm, ky.tab[K_LIST]);
      *cp++ = ky.tab[K_1];
      *cp++ = ky.tab[K_CR];
      *cp = 0;
      break;
    case K_LIST:
    case K_MENU:
    case K_CRT:
      if (gl.curr) {
	if (kp) {
	  kp = NULL;
	  *ky.comm = 0;
	}
	continue;
      }
      cb->push = cb->event = (k_n == K_MENU) ? E_MENU : 
	((k_n == K_CRT) ? E_CRT : E_LIST);
      draw_button(N_PUSH, 1);
      send_sig();
      if ((tabchrstr(ky.first, ky.tab[k_n], NULL))) {
	key = ky.tab[k_n] << 8;
	continue;
      }  
      break;
    case K_SC_RET:
      cb->event = E_SC_RET;
      send_sig();
      wait_susp();
      break;
    case K_FIFO:
    case K_RFIFO:
      if ((cb->s_pid && cb->in.fd) || cb->w_pid) {
	key = 0; /*  */
	continue;
      }
      cb->event = (k_n == K_RFIFO) ? E_RFIFO : E_FIFO;
      cb->push = E_FIFO;
      draw_button(N_PUSH, 1);
      send_sig();
      wait_susp();
      break;
    case K_PF+5:
    case K_DU:
    case K_RDU:
      if (gl.curr) continue;
      cb->push = E_DU;
      cb->event = (k_n == K_RDU) ? E_RDU : E_DU;
      draw_button(N_PUSH, 1);
      send_sig();
      break;
    case K_QUIT:
    case K_SUSP:
      if ((cb->event = (k_n == K_QUIT) ? E_QUIT : E_SUSP) == E_QUIT && 
	  cb->f.pin) {
	key = 0;
	continue;
      }
      if (cb->f.pin && !gl.curr) {
	kill(-cb->s_pid, SIGTERM);
	key = 0;
	continue;
      }
      clear_delay();
      send_sig();
      wait_susp();
      cb->push = E_QUIT;
      draw_button(N_PUSH, 0);
      if (gl.curr && k_n == K_QUIT) exit_key();
      go_cons((gl.curr) ? cb->tty : cb->cons);
      draw_button(N_PULL, 0);
      cb->push = cb->event = 0;
      draw_idle();
      break;
    case K_TAB:
      if (gl.curr) continue;
      clear_delay();
      wait_susp();
      strcpy(editor, gl.editor);
      strcat(editor, " ");
      strcat(editor, gl.config);
      cb->f.right = 0;
      go_sys(editor, tbl, 0);
      break;
    case K_F:
      if (!cb->vf.busy && (cb->event = read_pos(cb->x, cb->y)) != 0) {
	cb->f.right = 1;
	send_sig();
      }
      break;
    case K_f:
    case K_CR:
      if (cb->delay) {
	clear_delay();
      } else if ((cb->event = read_pos(cb->x, cb->y)) != 0) {
	cb->f.right = 0;
	send_sig();
      }
      break;
    default:
      if (k_n >= K__0 && k_n <= K__9)
	switch(k_n) {
	case K__0:
	  cp = set_comm(ky.comm, ky.tab[K_CANSEL]);
	  *cp++ = ky.tab[K_KUP];
	  *cp++ = ky.tab[K_CR];
	  *cp = 0;
	  break;
	case K__1:
	  cp = set_comm(ky.comm, ky.tab[K_CANSEL]);
	  *cp++ = ky.tab[K_KDN];
	  *cp++ = ky.tab[K_CR];
	  *cp = 0;
	  break;
	default:
	  break;
	}
      else if (k_n >= K_S_PF+1 && k_n <= K_S_PF+12) {
	while (cb->ff.lb == E_MENU) {
	  cansel(ky.tab[K_CANSEL]);
	  wait_susp();
	}
	cp = set_comm(ky.comm, ky.tab[K_MENU]);
	*cp++ = ky.tab[K_MENU];
	*cp++ = ky.tab[K_4];
	*cp++ = ky.tab[K_CR];
	*cp++ = ky.tab[K_1];
	*cp++ = ky.tab[K_CR];
	*cp++ = ky.tab[K_1+k_n-(K_S_PF+1)];
	*cp++ = ky.tab[K_CR];
	*cp = 0;
      } else if (k_n >= K_C_PF+1 && k_n <= K_C_PF+12) {
	while (cb->ff.lb == E_MENU) {
	  cansel(ky.tab[K_CANSEL]);
	  wait_susp();
	}
	cp = set_comm(ky.comm, ky.tab[K_MENU]);
	*cp++ = ky.tab[K_MENU];
	*cp++ = ky.tab[K_4];
	*cp++ = ky.tab[K_CR];
	*cp++ = ky.tab[K_2];
	*cp++ = ky.tab[K_CR];
	*cp++ = ky.tab[K_1+k_n-(K_C_PF+1)];
	*cp++ = ky.tab[K_CR];
	*cp = 0;
      } else if (k_n >= K_SC_PF+1 && k_n <= K_SC_PF+9 && !cb->f.pin) 
	go_cons(k_n - K_SC_PF);
      else if (k_n >= K_0 && k_n <= K_9) {
	switch(cb->c_f) {
	case C_CRT:
	case C_LIST:
	case C_MENU:
	case C_PAL:
	case C_WID:
	case C_TTY:
	case C_SYS:
	case C_SYS0:
	case C_SYS1:
	  if (k_n > K_0) {
	    cb->y = MY + (k_n - K_1)*cb->rline + 4;
	    draw_idle();
	  }
	  break;
	default:
	  if ((i = k_n - K_0 + N_MODE) >= cb->num) {
	    key = 0;
	    continue;
	  }
	  cb->push = cb->event = i;
	  draw_button(N_PUSH, 1);
	  send_sig();
	  break;
	}
      } else {
	if (!mask_ctl(key) && mask_1(key)) ;
	else if (k_n > 0) key = move_row(k_n, mask_key(key));
	else if (mask_ctl(key)) key = 0;
	continue;
      }
      break;
    }  
    key = 0;
  }
}

void send_sig(void)/*cb*/
{
  if (cb->f.pin) return;
  wait_susp();
  kill(cb->c_pid, SIGCONT);
}

int cansel(int key)/*cb*/
{
  if (!key && cb->f.macro == 3) cb->f.macro = 0;
  else if (cb->vf.in) cb->vf.in = 0;
  else if (cb->d_pid > 0 && (cb->d_pid = -cb->d_pid) != -1) 
    kill(-cb->d_pid, SIGKILL); /* ҥץؤ SIGTERM */
  else {
    if (cb->y < MY+2) clear_sel();
    clear_delay();
    cb->event = N_SEL;
    send_sig();
  }
  return 0;
}

void pid_str(char *str, int pid)/*cb*/
{
  strcpy(str, "/proc/");
  strcat(str, itoa(pid));
  strcat(str, "/stat");
}

void clear_delay(void)/*cb*/
{
  if (cb->f.pause) {
    cb->x -= 16;
    draw_idle();
    wait_cont();
  }
  cb->f.flow = cb->button = cb->vf.busy = cb->delay = 0;
  draw_idle();
}

unchar *set_comm(unchar *cp, int key)/*cb*/
{
  int i;
  uint u;

  if (cb->vf.busy) clear_delay();
  for (u = 0xff000000, i = 3; u; u >>= 8, i--)
    if (u & key) *cp++ = key >> (i*8);
  return cp;
}

int read_key(int tfd)/*cb*/
{
  int i, key, addr = 0, shift = 0;

  if (read(tfd, &addr, 2)) {
    unblank_screen();
    switch(addr & 0xf0) {
    case 0xf0:
      /* ԡ */
      while (read(tfd, &i, 2)) ;
    case 0x80:	/* ƻإե */
    case 0xa0:	/* JIS */
    case 0xc0:	/*  JIS */
      /*  */
      switch(addr & 0x0f) {
      case 0x4:	/* SHIFT */
	shift = 0x04;
	break;
      case 0x8:	/* CTRL */
	shift = 0x10;
	break;
      case 0xc:	/* SHIFTCTRL */
	shift = 0x14;
	break;
      case 0x0:	/* */
	shift = 0;
	break;
      }
      break;
    case 0x90:	/* ƻإե */
    case 0xb0:	/* JIS */
    case 0xd0:	/*  JIS */
      /*  */
      addr = 0;
      break;
    }
  }
  if (addr) addr >>= 8;
  if (!addr || (key = tabchrstr(ky.addr, addr, NULL)) == 0) return 0;
  else if (--key >= 0 && key <= 31)
    switch(shift) {
    case 0x00:
      if (key >= 13 && key <= 17) key = ky.ext[key-13];
      else key += PF;
      break;
    case 0x04:
      key += S_PF;
      break;
    case 0x10:
      key += C_PF;
      break;
    case 0x14:
      key += SC_PF;
      break;
    }
  else {
    key -= 32;
    if (key >= 1 && key <= 26)
      switch(shift) {
      case 0x00:
	key += 0x60;
	break;
      case 0x04:
	key += 0x40;
	break;
      case 0x10:
	break;
      case 0x14:
	if (key == 'p'-'a'+1) key = SC_p;
	else if (key == 'n'-'a'+1) key = SC_n;
	else key = 0;
	break;
      }
    else if (!key || (key >= 27 && key <= 30))
      switch(shift) {
      case 0x00:
	key += 0x40;
	break;
      case 0x04:
	key += 0x60;
	break;
      case 0x10:
	break;
      case 0x14:
	key = 0;
	break;
      }
    else if (key == 31)
      switch(shift) {
      case 0x00:
	key += 0x41;
	break;
      case 0x04:
	key += 0x40;
	break;
      case 0x10:
	break;
      case 0x14:
	key = 0;
	break;
      }
    else if (key >= 32 && key <= 43)
      switch(shift) {
      case 0x00:
	key += 0x30 - 0x20;
	break;
      case 0x04:
	key += 0x20 - 0x20;
	break;
      case 0x10:
	break;
      case 0x14:
	key = 0;
	break;
      }
    else if (key >= 44 && key <= 47) 
      switch(shift) {
      case 0x00:
	key += 0x20 - 0x20;
	break;
      case 0x04:
	key += 0x30 - 0x20;
	break;
      case 0x10:
	break;
      case 0x14:
	key = 0;
	break;
      }
  }
  return key;
}

void go_cons(int cons)/*cb*/
{
  int i, j = 0;
  struct vt_stat vtstat;

  if ((!gl.curr && cb->f.pin) || cb->vf.in || (cb->s_pid && cb->delay)) return;
  cb->f.off = 1;
  flush_key(ky.tfd);
  ioctl(ky.tfd, KDSKBMODE, K_XLATE);
  ioctl(ky.tfd, TCSETSW, &gl.text_termio);
  memcpy(ky.vram, (char*)gl.fb, VRAM_SIZE/2);
  memcpy(&ky.vram[VRAM_SIZE/2], &((char*)gl.fb)[VRAM_SIZE/2], VRAM_SIZE/2);
  memset(&((char*)gl.fb)[VRAM_SIZE/2], 0, VRAM_SIZE/2);
  set_vgamode(0);
  ioctl(ky.tfd, KDSETMODE, KD_TEXT);
  if (!cb->vf.wait && !check_proc(gl.c_str)) kill(cb->c_pid, SIGTSTP);
  if (cb->s_pid) {
    cb->input = -1;
    kill(cb->c_pid, SIGCONT);
  }
  if (gl.old) set_conspal();
  if (gl.curr && cb->tty == cons) {
    close(ky.tfd);
    set_conspal();
    kill(cb->k_pid, SIGTSTP);
    j = cb->vf.wait && check_proc(gl.c_str);
    ky.tfd = open("/dev/console", O_RDONLY);
  } else {
    ioctl(ky.tfd, VT_ACTIVATE, cons);
    do {
      ioctl(ky.tfd, VT_GETSTATE, &vtstat);
      usleep(10000);
    } while (vtstat.v_active == cb->tty);
    cb->cons = vtstat.v_active;
    while (1) {
      if (check_magic(M_TTY)) ioctl(ky.tfd, VT_ACTIVATE, cb->tty);
      ioctl(ky.tfd, VT_GETSTATE, &vtstat);
      if (vtstat.v_active == cb->tty) break;
      else cb->cons = vtstat.v_active;
      usleep(10000);
    }
    unblank_screen();
    if (!check_magic(M_FILE|M_PIPE)) j = cb->vf.wait && check_proc(gl.c_str);
  }
  if (!check_magic(M_PIPE)) set_vgamode(1);
  usleep(10000);
  ioctl(ky.tfd, TCSETSW, &gl.cb_termio);
  ioctl(ky.tfd, KDSKBMODE, K_RAW);
  ioctl(ky.tfd, KDSETMODE, KD_GRAPHICS);
  set_origin(cb->origin);
  layer_mode(3);
  layer_disp(2);
  if (cb->y < MY+2) clear_sel();
  if (j) /* ե read üڤؤꤽθɤ߹ߤäƤ */
    kill(cb->c_pid, SIGCONT);
  else {
    memcpy((char*)gl.fb, ky.vram, VRAM_SIZE/2);
    if ((i = check_magic(M_FILE|M_PIPE)) ||
	(!gl.curr && !i && !cb->s_pid && cb->c_f == C_PIPE)) {
      if (i) {
	cb->vf.stop = 1;
	kill(cb->c_pid, SIGCONT);
	while (cb->vf.stop) loop(10000);
      }
      if (check_magic(M_TTY)) res_magic(M_TTY);
      memset(&((char*)gl.fb)[VRAM_SIZE/2], 0, VRAM_SIZE/2);
    } else 
      memcpy(&((char*)gl.fb)[VRAM_SIZE/2], &ky.vram[VRAM_SIZE/2], VRAM_SIZE/2);
    if ((cb->delay && !cb->f.pause) || i) kill(cb->c_pid, SIGCONT);
    unblank_screen();
    if (!gl.curr && !i && !cb->s_pid && 
	(cb->c_f == C_TTY || cb->c_f == C_PIPE))
      while (cb->ff.lb == E_MENU) {
	/* [ * ] ȴޤǥ롼 */
	cansel(ky.tab[K_CANSEL]);
	wait_susp();
      }
  }
  cb->f.off = 0;
  flush_key(ky.tfd);
}

void go_sys(char *sys, unchar *tbl, int uid)/*cb*/
{
  int i, j, pid;
  struct stat st, st0;
  char y_str[24], **argv;
  
  wait_susp();
  stat(gl.config, &st);
  flush_key(ky.tfd);
  ioctl(ky.tfd, KDSKBMODE, K_XLATE);
  write(1, ky.echo, strlen(ky.echo));
  ioctl(ky.tfd, TCSETSW, &gl.text_termio);
#if 0
  if (tbl) ioctl(ky.tfd, KD_SETKANJICODE, &gl.kanjimode);
#endif
  memcpy(ky.vram, (char*)gl.fb, VRAM_SIZE/2);
  memcpy(&ky.vram[VRAM_SIZE/2], &((char*)gl.fb)[VRAM_SIZE/2], VRAM_SIZE/2);
  memset(&((char*)gl.fb)[VRAM_SIZE/2], 0, VRAM_SIZE/2);
  set_vgamode(0);
  ioctl(ky.tfd, KDSETMODE, KD_TEXT);
  if (!tbl) set_conspal();
  else if (gl.old) palette(0, tbl);
  else {
    ky.pal[3] = '0';
    ky.pal[4] = ky.num[(unsigned int)gl.color[0]];
    ky.pal[6] = ky.num[(unsigned int)gl.color[1]];
    ky.pal[8] = ky.num[(unsigned int)gl.color[2]];
    write(1, ky.pal, 10);
    ky.pal[3] = '7';
    ky.pal[4] = ky.num[(unsigned int)gl.color[3]];
    ky.pal[6] = ky.num[(unsigned int)gl.color[4]];
    ky.pal[8] = ky.num[(unsigned int)gl.color[5]];
    write(1, ky.pal, 10);
    ky.pal[3] = 'f';
    ky.pal[4] = ky.num[(unsigned int)gl.color[6]];
    ky.pal[6] = ky.num[(unsigned int)gl.color[7]];
    ky.pal[8] = ky.num[(unsigned int)gl.color[8]];
    write(1, ky.pal, 10);
  }
  close(ky.tfd);
  for (i = 0; (i = tabchrstr(sys, ';', NULL)); sys = &sys[i]) {
    sys[i-1] = 0;
    system(sys);
  }
  ky.tstp = (int)signal(SIGTSTP, SIG_IGN);
  cb->vf.wait = 1;
  if (!(argv = alloc_sys(sys))) {
    save_log("cb: %s: %s\n", sys, strerror(ENOENT));
    pid = 0;
  } else if (!(pid = fork())) {
    setsid();
    signal(SIGTSTP, (__sighandler_t)ky.tstp);
    if (!tbl && uid) setuid(gl.uid);
    execv(argv[0], &argv[1]);
  }
  if (pid) {
    pid_str(y_str, pid);
    while (check_proc(y_str) < 0) usleep(10000);
    while (1) {
      if ((i = check_proc(y_str)) == 1) kill(pid, SIGCONT);
      else if (i < 0) {
	while (get_vactive() != cb->tty) usleep(10000);
	free_sys(argv);
	break;
      }
      if (check_proc(gl.c_str) < 0) {
	setuid(0);
	kill(pid, SIGKILL);
	while (check_proc(y_str) >= 0) usleep(10000);
	exit_key();
      }
      usleep(500000);
    }
  }
  if (!tbl && uid) setuid(0);
  signal(SIGTSTP, (__sighandler_t)ky.tstp);
  stat(gl.config, &st0);
  if (st.st_mtime != st0.st_mtime) {
    stat(gl.config, &st);
    init_chp(1, ky.tab, ky.first);
    if (cb->loop) set_delay(-cb->loop);
    if (gl.old && tbl) set_tbl(tbl);
    cb->vf.config = 1;
    kill(cb->c_pid, SIGCONT);
    while (cb->vf.config != 2) usleep(10000);
    cb->vf.config = 3;
  }
  if (cb->f.right) {
    printf("\n-- hit any key --\n");
    ioctl(0, TCSETSW, &gl.cb_termio);
    while (!read(0, &j, 1)) usleep(10000);
    unblank_screen();
  }
  if (!gl.old && tbl) set_conspal();
  write(1, ky.echo, strlen(ky.echo));
  set_vgamode(1);
  usleep(10000);
  ioctl(0, TCSETSW, &gl.cb_termio);
  ioctl(0, KDSKBMODE, K_RAW);
  ioctl(0, KDSETMODE, KD_GRAPHICS);
  set_origin(cb->origin);
  layer_mode(3);
  layer_disp(2);
  memcpy((char*)gl.fb, ky.vram, VRAM_SIZE/2);
  memcpy(&((char*)gl.fb)[VRAM_SIZE/2], &ky.vram[VRAM_SIZE/2], VRAM_SIZE/2);
  unblank_screen();
  kill(cb->c_pid, SIGCONT);
  while (cb->ff.lb == E_MENU) { /* [ * ] ȴޤǥ롼 */
    cansel(ky.tab[K_CANSEL]);
    wait_susp();
  }
  while ((ky.tfd = open("/dev/console", O_RDWR)) < 0) ;
  flush_key(ky.tfd);
  cb->vf.wait = 0;
}

void set_vgamode(int f)/*cb*/
{
  if (ky.ws.ws_col == cb->ws.col && !f) return;
  sw_vgamode((f) ? cb->ws.col == WS_COL1 : ky.ws.ws_col == WS_COL1);
}

char **alloc_sys(char *sys)/*cb*/
{
  int i, j, k;
  char **argv, *cp;
  static char path[1000];

  if (!*path) strcpy(path, getenv("PATH"));
  while (*sys == ' ') sys++;
  for (cp = sys; *cp; cp++) if (*cp == '\t') *cp = ' ';
  for (cp = sys, i = 0, k = 3; *cp; ) {
    while (*cp && *cp != ' ') cp++;
    for (; *cp && *cp == ' '; cp++) ;
    if (!*cp) continue;
    k++;
  }
  argv = (char **)calloc(sizeof(char*), k);
  i = j = 0;
  cp = sys;
  do {
    while (*cp == ' ') cp++;
    if ((i = tabchrstr(cp, ' ', NULL))) cp[i-1] = 0;
    if (!j) {
      argv[1] = strdup(cp);
      if (set_path(argv, path) < 0) {
	strcpy(sys, argv[1]);
	free(argv[1]);
	free(argv);
	return NULL;
      }
      j++;
    } else argv[j] = strdup(cp);
    j++;
    if (k == j+1) break;
    cp = &cp[i];
  } while (i);
  argv[j] = NULL;
  return argv;
}

void free_sys(char **argv)/*cb*/
{
  int i;

  for (i = 0; argv[i]; i++) free(argv[i]);
  free(argv);
}

void set_tbl(unchar *tbl)/*cb*/
{
  int i, j;

  for (i = j = 0; i < 3*16; i++)
    if ((i >= 0 && i <= 2) || (i >= 21 && i <= 23) || (i >= 45 && i <= 47)) 
      tbl[i] = gl.color[j++] << 4;
}

