#include "cb.h"
#include "vram.h"
static char *spc = " ";
void vramsetcrtc(ushort tab[])/*cb*/
{ /* ̥⡼ */
  int i, req[36];
  ushort *p;
  int ffd = open("/dev/fb", O_RDWR);
  
  req[0] = 35 * sizeof(int) + sizeof(int);
  p = (ushort*)&req[1];
  for (i = 0; i < 35; i++) {
    *p++ = i;
    *p++ = tab[i];
  }  
  ioctl(ffd, FBIOCSETCRTC, req);
  close(ffd);
}

uint *vramgetaddr(int *fb, int *bf)/*cb*/
{
  if (fb) *fb = vram.fb;
  if (bf) *bf = (int)vram.bf;
  return &vram.bf[LINE_LWORDS*(MY+PAGE_LINES)];
}

void vramsetfb(int fb)/*cb*/
{ /* ɽɥ쥹 */
  vram.addr = fb;
}

uint vramsetaddr(uint addr)/*cb*/
{ /* VRAM ɥ쥹 */
  return addr+vram.fb;
}

void vraminit(int fb, int font)/*cb*/
{ /* ɥ쥹 */
  if (fb) {
    vram.addr = vram.fb = fb;
    memset((char*)fb, 0, VRAM_SIZE);
  }
  if (font) vram.font = font;
  vram.end.i = vram.fb + 0x80000;
}

void  vrambox(int x1, int y1, int x2, int y2, int col, int mm)/*cb*/
{ /* boxɽ */
  vramline(x1, y1, x2, y1, col, mm, 0);
  vramline(x2, y1+1, x2, y2-1, col, mm, 0);
  vramline(x1, y2, x2, y2, col, mm, 0);
  vramline(x1, y1+1, x1, y2-1, col, mm, 0);
}

void  vramline(int x1, int y1, int x2, int y2, int col, int mm, int fb)/*cb*/
{ /* ľɽ */
  uint u, v, *addr;
  int   p_d, q_d, y_inc;
  int   p_i, q_i;

  if (x2 < x1) {
    u = x2;
    x2 = x1;
    x1 = u;
    u = y2;
    y2 = y1;
    y1 = u;
  }
  u = col << ((x1 & 1) << 2);
  p_d = x2 - x1;
  q_d = y2 - y1;
  if (q_d < 0) {
    q_d = -q_d;
    y_inc = -LINE_LWORDS;
  } else {
    y_inc = LINE_LWORDS;
  }
  p_i = p_d;
  q_i = q_d;
  p_d *= 2;
  q_d *= 2;
  addr = (uint*)((int)get_addr(x1, y1)+((fb) ? fb : vram.addr));
  v = *addr;
  switch(mm) {
  case V_SET:
    draw(v |= u);
    break;
  case V_RES:
    draw(v &= ~u);
    break;
  case V_NOT:
    draw(v ^= u);
    break;
  default:
    break;
  }
  *addr = v;
}

void vramclear(int xs, int ys, int xe, int ye)/*cb*/
{ /* 襯ꥢ */
  static uint clear[LINE_LWORDS];
  int y;
  uint *addr;

  if (!vram.fb) return;
  addr = (uint*)((int)get_addr(xs, ys)+vram.addr);
  for (y = ys; y < ye; y++, addr += LINE_LWORDS) 
    memcpy(addr, clear, LINE_BYTES);
}

void vrampaint(int xs, int ys, int xe, int ye, uint color, int mode, int fb)/*cb*/
{ /* boxɤ٤ */
  int i, y;
  uint *addr, c;
  static uint ctab[16];

  if (!ctab[1]) {
    for (i = 1; i < 16; i++) {
      for (y = 0, c = i; y < 8; y++) 
	c = (c << 4) | i;
      ctab[i] = c;
    }
  }  
  if (xs % 8 || xe % 8) 
    for (y = ys; y <= ye; y++) vramline(xs, y, xe, y, color, mode, fb);
  else
    switch(mode) {
    case V_SET:
      for (y = ys; y <= ye; y++) {
	addr = (uint*)((int)get_addr(xs, y)+((fb) ? fb : vram.addr));
	for (i = (xe-xs)/8; i; i--) *addr++ |= ctab[color];
      }  
      break;
    case V_RES:
      for (y = ys; y <= ye; y++) {
	addr = (uint*)((int)get_addr(xs, y)+((fb) ? fb : vram.addr));
	for (i = (xe-xs)/8; i; i--) *addr++ &= ~ctab[color];
      }  
      break;
    case V_NOT:
      for (y = ys; y <= ye; y++) {
	addr = (uint*)((int)get_addr(xs, y)+((fb) ? fb : vram.addr));
	for (i = (xe-xs)/8; i; i--) *addr++ ^= ctab[color];
      }  
      break;
    }  
}

void vramprintf(uint *fontbuf, void *ss, void *se, int n, int kanji)/*cb*/
{ /* ʸ */
  static char *cs, *ce;
  static int i, t, pal;
  static uint conv1[256], conv2[256], *convp;
  int f, j, k, arg[4];
  static unchar tmp[32], tmp2[32], *tp;
  static unchar c;
  uint *addr;

  if (!conv1[1]) {
    init_color(14, conv1);
    init_color(11, conv2);
    convp = gl.convdata;
    for (i = 16; i < 32; i++) tmp[i] = tmp2[i] = 0xff;
  }
  f = vram.addr == vram.fb;
  switch(kanji) {
  case J_UP:
    kanji = J_EUC;
  case J_SPC:
    k = 0;
    break;
  default:
    k = cb->rline/2-8;
    break;
  }
  if (ss) {
    cs = ss;
    ce = se;
    i = t = 0;
    if (!n) n--;
    gl.code_1 = gl.code_2 = 0;
    pal = 0;
    convp = gl.convdata;
  }
  for (; i < cb->ws.col && n; n--, cs++, i++) {
    if (t || cs > ce) c = *spc;
    else c = *cs;
    if (!c || c == '\r' || c == '\n') c = *spc;
    do {
      if (c == 0x0c) c = *spc;
      if (c == '\t') {
	if (kanji == J_SPC) c = ' ';
	else {
	  t = 8 - (i & 7);
	  c = ' ';
	  cs++;
	}
	continue;
      } else if (cs > ce) continue;
      if (c == '_' && cs[1] == BS && cs[2] != '_' && cs[3] != BS) {
	cs++;
	i--;
	n++;
	pal = 1;
	convp = conv1;
	goto jump;
      } else if (c == '_' && cs[1] == '_' && cs[2] == BS && cs[3] == BS) {
	cs += 3;
	i--;
	n++;
	pal = 2;
	convp = conv1;
	goto jump;
      } else if (c != ' ' && cs[2] == BS && cs[3] == BS) {
	cs += 3;
	i--;
	n++;
	pal = 2;
	convp = conv2;
	goto jump;
      } else if (c != ' ' && cs[1] == BS) {
	cs++;
	i--;
	n++;
	pal = 1;
	convp = conv2;
	goto jump;
      }
      if (pal > 0) pal--;
      else if (!pal--) convp = gl.convdata;
    } while (0);
    if (!(j = kanji == J_ANK || kanji == J_BIN)) {
      if (!gl.code_1) {
	if (is_euckana_1_byte(c)) {
	  gl.code_1 = c;
	  continue;
	} else if (is_euc_1_byte(c)) {
	  gl.code_1 = c & 0x7f;
	  continue;
	}
      } else if (gl.code_1 == 0x8e)
	if (is_euckana_2_byte(c)) gl.code_2 = c;
	else gl.code_1 = gl.code_2 = 0;
      else if (is_euc_2_byte(c)) gl.code_2 = c & 0x7f;
      else gl.code_1 = gl.code_2 = 0;
    }
    if (j || !gl.code_1 || (!j && gl.code_1 == 0x8e)) {
      if (!j && gl.code_1 == 0x8e) {
	c = gl.code_2;
	gl.code_1 = 0;
	i--;
	n++;
      }
      if (vram.font) 
	tp = (unchar*)vram.font + ANK_OFFS + (c << 4);
      else {
	arg[0] = c;
	arg[1] = (int)tmp;
	ioctl(gl.kfd, KROMIOCANK, arg);
	tp = tmp;
      }	
      if (f && k) {
	if ((addr = &fontbuf[i]) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 2:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 1:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  break;
	}
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 2:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 1:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  break;
	}
      } else {
	addr = &fontbuf[i];
	switch(k) {
	case 4:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 2:
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 1:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  break;
	}
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 2:
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 1:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  break;
	}
      }
    } else {
      if (f && k) {
	arg[0] = gl.code_1;
	arg[1] = gl.code_2;
	arg[2] = (int)tmp2;
	arg[3] = (int)tmp;
	ioctl(gl.kfd, KROMIOCK16, arg);
	if ((addr = &fontbuf[i]) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 2:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 1:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  break;
	}
	tp = tmp2;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 2:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 1:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  break;
	}
	if ((addr = &fontbuf[i-1]) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 2:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 1:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  break;
	}
	tp = tmp;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	*addr = convp[*tp++];
	if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 2:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	case 1:
	  *addr = 0;
	  if ((addr += LINE_LWORDS) >= vram.end.p) addr -= PAGE_LWORDS;
	  break;
	}
      } else {
	arg[0] = gl.code_1;
	arg[1] = gl.code_2;
	arg[2] = (int)tmp2;
	arg[3] = (int)tmp;
	ioctl(gl.kfd, KROMIOCK16, arg);
	addr = &fontbuf[i];
	switch(k) {
	case 4:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 2:
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 1:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  break;
	}
	tp = tmp2;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 2:
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 1:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  break;
	}
	if ((addr = &fontbuf[i-1]) >= vram.end.p) addr -= PAGE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 2:
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 1:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  break;
	}
	tp = tmp;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	*addr = convp[*tp++];
	addr += LINE_LWORDS;
	switch(k) {
	case 4:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 2:
	  *addr = 0;
	  addr += LINE_LWORDS;
	case 1:
	  *addr = 0;
	  addr += LINE_LWORDS;
	  break;
	}
      }
      gl.code_1 = gl.code_2 = 0;
    }
    if (t) {
      t--;
      cs--;
    }
jump:
  }
}
